//#include "stdafx.h"

#include<windows.h>
#include"CreateDIBfromFile248.h"

int CreateDIBfromFile248(char *lpFileName,LPVOID *lppPixel,LPBITMAPINFO *lppBmpInfo,CDF type)
{
	HANDLE fh;
	DWORD dwFileSize,dwReadSize;
	LPBYTE lpbuf;

	LPBITMAPFILEHEADER lpbmpfh;
	LPBITMAPINFO lpbmpInfo;

	LPBYTE lpbmpPixel;
	LPRGBQUAD lpColorTable;
	int bitCount,nColorTable,iWidth,iHeight,iLenSrc,iLenDst,x,y;

	fh=CreateFile(lpFileName,GENERIC_READ,0,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(fh==INVALID_HANDLE_VALUE){
		MessageBox(NULL,"t@CJ܂",lpFileName,MB_OK);
		return -1;
	}
	dwFileSize=GetFileSize(fh,NULL);
	lpbuf=(LPBYTE)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,dwFileSize);
	ReadFile(fh,lpbuf,dwFileSize,&dwReadSize,NULL);
	CloseHandle(fh);

	lpbmpfh=(LPBITMAPFILEHEADER)lpbuf;
	lpbmpInfo=(LPBITMAPINFO)(lpbuf+sizeof(BITMAPFILEHEADER));
	bitCount=lpbmpInfo->bmiHeader.biBitCount;
	if(lpbmpfh->bfType!=('M'<<8)+'B' || (bitCount!=24 && bitCount!=8)){
		HeapFree(GetProcessHeap(),0,lpbuf);
   		MessageBox(NULL,"24 or 8 rbgBMPt@Cǂݍ߂܂",lpFileName,MB_OK);
		return -2;
	}

	lpbmpPixel=lpbuf + lpbmpfh->bfOffBits;
	iWidth=lpbmpInfo->bmiHeader.biWidth;
	iHeight=lpbmpInfo->bmiHeader.biHeight;

	if(type==CT && bitCount!=8) type=BY;
	else if(type==DEF){
		if(bitCount==24) type=BY;
		else if(bitCount==8) type=CT;
	}

	if(iWidth*(bitCount/8)%4) iLenSrc=iWidth*(bitCount/8)+(4-iWidth*(bitCount/8)%4);
	else iLenSrc=iWidth*(bitCount/8);
	if(iWidth*(type/8)%4) iLenDst=iWidth*(type/8)+(4-iWidth*(type/8)%4);
	else iLenDst=iWidth*(type/8);

	*lppPixel=HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,iLenDst*iHeight);
	if(type==CT) *lppBmpInfo=(LPBITMAPINFO)HeapAlloc(GetProcessHeap(),
		HEAP_ZERO_MEMORY,sizeof(BITMAPINFO)+255*4);
	else *lppBmpInfo=(LPBITMAPINFO)HeapAlloc(GetProcessHeap(),
		HEAP_ZERO_MEMORY,sizeof(BITMAPINFO));

	switch(bitCount){
		case 24:
			for(y=0;y<iHeight;y++)
				for(x=0;x<iWidth;x++)
					CopyMemory(*(LPBYTE*)lppPixel+x*(type/8)+y*iLenDst,
						lpbmpPixel+x*3+y*iLenSrc,3);
			break;
		case 8:
			nColorTable=lpbmpInfo->bmiHeader.biClrUsed;
			if(nColorTable==0) nColorTable=256;
			lpColorTable=lpbmpInfo->bmiColors;
			switch(type){
				case DW: case BY:
					for(y=0;y<iHeight;y++)
						for(x=0;x<iWidth;x++)
							CopyMemory(*(LPBYTE*)lppPixel+x*(type/8)+y*iLenDst,
								lpColorTable+lpbmpPixel[x+y*iLenSrc],3);
					break;
				case CT:
					for(y=0;y<iHeight;y++)
						for(x=0;x<iWidth;x++)
							(*(LPBYTE*)lppPixel)[x+y*iLenDst]=lpbmpPixel[x+y*iLenSrc];
					for(x=0;x<nColorTable;x++)
						(*lppBmpInfo)->bmiColors[x]=lpColorTable[x];
					break;
			}
			break;
	}
	CopyMemory(*lppBmpInfo,&lpbmpInfo->bmiHeader,sizeof(BITMAPINFOHEADER));
	(*lppBmpInfo)->bmiHeader.biBitCount=type;

	HeapFree(GetProcessHeap(),0,lpbuf);
	return iLenDst;
}

void DeleteDIB(LPVOID *lppPixel,LPBITMAPINFO *lppBmpInfo)
{
	if(*lppPixel!=NULL){
		HeapFree(GetProcessHeap(),0,*lppPixel);
		*lppPixel=NULL;
	}
	if(*lppBmpInfo!=NULL){
		HeapFree(GetProcessHeap(),0,*lppBmpInfo);
		*lppBmpInfo=NULL;
	}
}

void DeleteDIB(LPVOID *lppPixel)
{
	if(*lppPixel!=NULL){
		HeapFree(GetProcessHeap(),0,*lppPixel);
		*lppPixel=NULL;
	}
}

void Write32(HANDLE fh,const DWORD *lpPixel,int w,int h)
{
	int extra;
	if(w*3%4) extra=4-w*3%4;
	else extra=0;

	DWORD dwWriteSize;
	int zero=0;
	for(int y=0;y<h;y++){
		for(int x=0;x<w;x++)
			WriteFile(fh,lpPixel+x+y*w,3,&dwWriteSize,NULL);
		if(extra) WriteFile(fh,&zero,extra,&dwWriteSize,NULL);
	}	//s̃oCg4̔{ɕ␳
}

int SaveDIB(char *lpFileName,const BYTE *lpPixel,const BITMAPINFO *lpBmpInfo)
{
	BITMAPINFOHEADER bmpInfoH;
	CopyMemory(&bmpInfoH,&lpBmpInfo->bmiHeader,sizeof(BITMAPINFOHEADER));

	int bitCount=bmpInfoH.biBitCount;
	if(bitCount!=32 && bitCount!=24 && bitCount!=8){
		char str[8];
		wsprintf(str,"%d",bitCount);
		MessageBox(NULL,"ΉĂȂrbgł",str,MB_OK);
		return -1;
	}
	if(bitCount==32) bmpInfoH.biBitCount=24;

	int w=bmpInfoH.biWidth , h=bmpInfoH.biHeight;
	DWORD nColorTable=bmpInfoH.biClrUsed;
	if(bitCount==8 && nColorTable==0) nColorTable=256;

	int len;
	if(w*(bitCount/8)%4) len=w*(bitCount/8)+(4-w*(bitCount/8)%4);
	else len=w*(bitCount/8);

	BITMAPFILEHEADER bmpfh;
	bmpfh.bfSize=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+len*h;
	bmpfh.bfType=('M'<<8)+'B';
	bmpfh.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);
	if(bitCount==8){
		bmpfh.bfSize+=nColorTable*4;
		bmpfh.bfOffBits+=nColorTable*4;
	}

	HANDLE fh=CreateFile(lpFileName,GENERIC_WRITE,0,NULL,
		CREATE_NEW,FILE_ATTRIBUTE_NORMAL,NULL);
	if(fh==INVALID_HANDLE_VALUE){
		MessageBox(NULL,"̃t@Cɑ݂Ă܂",lpFileName,MB_OK);
		return -2;
	}

	DWORD dwWriteSize;
	WriteFile(fh,&bmpfh,sizeof(BITMAPFILEHEADER),&dwWriteSize,NULL);
	WriteFile(fh,&bmpInfoH,sizeof(BITMAPINFOHEADER),&dwWriteSize,NULL);
	if(bitCount==8)
		WriteFile(fh,lpBmpInfo->bmiColors,nColorTable*4,&dwWriteSize,NULL);

	if(bitCount==32) Write32(fh,(LPDWORD)lpPixel,w,h);
	else WriteFile(fh,lpPixel,len*h,&dwWriteSize,NULL);

	CloseHandle(fh);
	return 0;
}

int SaveDDB(char *lpFileName,HDC hMemDC,int width,int height)
{
	BITMAPINFO bmpInfo;
	LPBYTE lpPixel;
	//DIB̏ݒ肷
	bmpInfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	bmpInfo.bmiHeader.biWidth=width;
	bmpInfo.bmiHeader.biHeight=height;
	bmpInfo.bmiHeader.biPlanes=1;
	bmpInfo.bmiHeader.biBitCount=24;
	bmpInfo.bmiHeader.biCompression=BI_RGB;
	//DIBSection쐬
	HBITMAP hBmp=CreateDIBSection(NULL,&bmpInfo,DIB_RGB_COLORS,(void**)&lpPixel,NULL,0);
	HDC hdcTemp=CreateCompatibleDC(NULL);
	SelectObject(hdcTemp,hBmp);

	BitBlt(hdcTemp,0,0,width,height,hMemDC,0,0,SRCCOPY);
	int ret=SaveDIB(lpFileName,lpPixel,&bmpInfo);

	DeleteDC(hdcTemp);
	DeleteObject(hBmp);
	return ret;
}
