#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "memory_allocate.h"
#include "TABLE.h"
#include "kmeans.h"

#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

void kmeans(char *fn,char *fnw){
	
	int i,j,k,l,c;
	int CS=4;
	int *ClaNum;//Number of data of class
	double *m,*ClassData,*dist,min,JValue;
	FILE *fp;

	double *Data;
	int Num,Dim,STEP,MAXSTEP=50;

	Data=DataGet(fn,&Num,&Dim);
	
	m=dvector(0,CS*Dim);//mean
	dist=dvector(0,CS);//distance between center of class and some data
	ClaNum=ivector(0,CS);//
	ClassData=dvector(0,CS*Num*Dim);//

	//First Step
	srand((unsigned) time(NULL));

	for(i=0;i<CS;i++){
		k=int(Num*rand()/RAND_MAX);//@k become between from 0 to Num
		for(j=0;j<Dim;j++){
			m[i*Dim+j]=Data[k*Dim+j];
		}
	}

	STEP=0;
	while(STEP<MAXSTEP){// START of ROOP

		//Second Step
		for(i=0;i<CS;i++){
			ClaNum[i]=0;
		}

		for(k=0;k<Num;k++){
			min=1000000;
			for(i=0;i<CS;i++){
				dist[i]=0;
				for(j=0;j<Dim;j++){//calculation of distance
					dist[i]+=(m[i*Dim+j]-Data[k*Dim+j])*(m[i*Dim+j]-Data[k*Dim+j]);
				}
				if(min>dist[i]){
					min=dist[i];
					c=i;
				}
			}
			//map Class and data 
			for(j=0;j<Dim;j++){
				ClassData[c*Num*Dim+ClaNum[c]*Dim+j]=Data[k*Dim+j];
			}
			ClaNum[c]++;//initiall value is 1, but array start is 0 

		}

		//Third Step
		for(i=0;i<CS;i++){
			for(j=0;j<Dim;j++){
				m[i*Dim+j]=0;
				for(l=0;l<ClaNum[i];l++){
					m[i*Dim+j]+=ClassData[i*Num*Dim+l*Dim+j];
				}
				m[i*Dim+j]/=ClaNum[i];
			}
		}

		//Four Step
		JValue=0;// evaluation value
		for(i=0;i<CS;i++){
			for(j=0;j<Dim;j++){
				for(l=0;l<ClaNum[i];l++){
					JValue+=(m[i*Dim+j]-ClassData[i*Num*Dim+l*Dim+j])*(m[i*Dim+j]-ClassData[i*Num*Dim+l*Dim+j]);
				}
			}
		}
		JValue/=Num;

		printf("JValue=%f\n",JValue);
		STEP++;

	}// END of ROOP

	
	if((fp=fopen(fnw,"w"))==NULL){
		printf("%s file open error!!\n",fnw);
		getchar();
		exit(1);
	}

	for(i=0;i<Dim;i++){//n񖼂̏o
		fprintf(fp,"Dim%d\t",i+1);
	}
	fprintf(fp,"LABEL\n");//"LABEL"̏o
	for(i=0;i<CS;i++){
		for(l=0;l<ClaNum[i];l++){
			for(j=0;j<Dim;j++){
				fprintf(fp,"%f\t",ClassData[i*Num*Dim+l*Dim+j]);
			}
			fprintf(fp,"%d\n",i);
		}
	}
	fclose(fp);

}

MapTable kmeans(double *data,int Num,int Dim,int CLASS){


	int i,j,k,c;
	double *dist,min,JValue;
	int STEP,MAXSTEP=50;

	MapTable KM;

	KM.Dim=Dim;
	KM.Num=Num;
	KM.CS=CLASS;
		
	KM.data=dvector(0,KM.Num*KM.Dim);
	KM.mean=dvector(0,KM.CS*KM.Dim);//mean
	KM.ClaNum=ivector(0,KM.CS);//
	KM.MapLabel=ivector(0,KM.Num);//
	dist=dvector(0,KM.CS);//distance between center of class and some data

	for(k=0;k<KM.Num;k++){
		for(j=0;j<KM.Dim;j++){
			KM.data[k*KM.Dim+j]=data[k*KM.Dim+j];
		}
	}

	//First Step
	srand((unsigned) time(NULL));

	for(i=0;i<KM.CS;i++){
		k=int(KM.Num*rand()/RAND_MAX);//@k become between from 0 to Num
		for(j=0;j<KM.Dim;j++){
			KM.mean[i*KM.Dim+j]=KM.data[k*KM.Dim+j];
		}
	}

	STEP=0;
	while(STEP<MAXSTEP){//MAXSTEP){// START of ROOP

		//Second Step
		for(i=0;i<KM.CS;i++){
			KM.ClaNum[i]=0;
		}

		for(k=0;k<KM.Num;k++){
			min=1000000;
			for(i=0;i<KM.CS;i++){
				dist[i]=0;
				for(j=0;j<KM.Dim;j++){//calculation of distance
					dist[i]+=(KM.mean[i*KM.Dim+j]-KM.data[k*KM.Dim+j])*(KM.mean[i*KM.Dim+j]-KM.data[k*KM.Dim+j]);
				}
				if(min>dist[i]){
					min=dist[i];
					c=i;
				}
			}
			//map Class and data 		
			KM.MapLabel[k]=c;
			KM.ClaNum[c]++;//initiall value is 1, but array start is 0 

		}

		//Third Step
		for(i=0;i<KM.CS;i++){
			for(j=0;j<KM.Dim;j++){
				KM.mean[i*KM.Dim+j]=0;
			}
		//	printf("%d\n",KM.ClaNum[i]);
		}

		for(j=0;j<KM.Dim;j++){
			for(k=0;k<KM.Num;k++){
				KM.mean[KM.MapLabel[k]*KM.Dim+j]+=KM.data[k*KM.Dim+j];
			}
		}

		for(i=0;i<KM.CS;i++){
			for(j=0;j<KM.Dim;j++){
			KM.mean[i*KM.Dim+j]/=KM.ClaNum[i];
			}
		}

		//Four Step
		JValue=0;// evaluation value
		for(k=0;k<KM.Num;k++){
			for(j=0;j<KM.Dim;j++){
				JValue+=(KM.mean[KM.MapLabel[k]*KM.Dim+j]-KM.data[k*KM.Dim+j])*(KM.mean[KM.MapLabel[k]*KM.Dim+j]-KM.data[k*KM.Dim+j]);
			}
		}
		JValue/=KM.Num;

	//	printf("JValue%d=%f\n",STEP,JValue);
		STEP++;

	}// END of ROOP

	for(i=0;i<KM.CS;i++){
		printf("%dCLASS  %ddata :Mean\t",i,KM.ClaNum[i]);
		for(j=0;j<KM.Dim;j++){
			printf("%f\t",KM.mean[i*KM.Dim+j]);
		}
		printf("\n");
	}
	return KM;


}


