#include "stdafx.h"
#include <math.h>
#include <stdlib.h>
#include <string.h>

#include "memory_allocate.h"
#include "MSI.h"
#include "svd_v2.h"
#include "TABLE.h"
#include "SPECT.h"
#include "NaturalVision.h"
#include "kmeans.h"
#include "Dye.h"

#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

Table Minus10PowerTable(void)
{
	int i;
	Table	Minus10Power;
	double dtmp,dpar;


	Minus10Power.Min= 0.0;
	Minus10Power.Max= 10.0;
	Minus10Power.Size=100000;

	Minus10Power.data=dvector(0,Minus10Power.Size);

	for( i=0 ; i<Minus10Power.Size ; i++ ) {
		dtmp = (double)(i) / Minus10Power.Size;
		dpar = dtmp * (Minus10Power.Max-Minus10Power.Min) + Minus10Power.Min;
		Minus10Power.data[i] = pow(double(10), (-1*dpar));
	}

	return Minus10Power;

}

void	Do_Minus10Power(double *Input,Table *Minus10Power)
{	
	int indx;
	double	dtmp;

	
	dtmp = (*Input-Minus10Power->Min) / (Minus10Power->Max-Minus10Power->Min);
	if( dtmp > 1.0 ){
		indx = (int) ( Minus10Power->Size - 1 ) ;
	}else if( dtmp < 0. ) {
		indx = (int) ( 0 ) ;
	}else{
		indx = (int) ( dtmp * Minus10Power->Size ) ;
	}
	*Input=Minus10Power->data[indx];

}

Table MinusLog10Table(void)
{
	
	int i;
	Table	MinusLog10;
	double dtmp,dpar;


	MinusLog10.Min= 0.0001;
	MinusLog10.Max= 1.0;
	MinusLog10.Size=100000;

	MinusLog10.data=dvector(0,MinusLog10.Size);

	for( i=0 ; i<MinusLog10.Size ; i++ ) {
		dtmp = (double)(i) / MinusLog10.Size;
		dpar = dtmp * (MinusLog10.Max-MinusLog10.Min) + MinusLog10.Min;
		MinusLog10.data[i] = -log10(dpar);
	}

	return MinusLog10;

}

void	Do_MinusLog10(double *Input,Table *MinusLog10)
{	
	int indx;
	double	dtmp;
	
	dtmp = (*Input-MinusLog10->Min) / (MinusLog10->Max-MinusLog10->Min);
	if( dtmp >= 1.0 ){
		indx = (int) ( MinusLog10->Size - 1 );
	}else if( dtmp < 0. ) {
		indx = (int) ( 0 ) ;
	}else{
		indx = (int) ( dtmp * MinusLog10->Size ) ;
	}
	*Input=MinusLog10->data[indx];

}

void NormalizeDyespec(Dye *dye){
	
	int i,j;
	double max[3];
	for(j=0;j<dye->Num;j++){
		max[j]=-10000;
		for(i=dye->START;i<dye->END;i+=dye->INTERVAL){
			if(max[j]<dye->spec.data[i*dye->Num+j]){
				max[j]=dye->spec.data[i*dye->Num+j];
			}
		}
	}

	for(j=0;j<dye->Num;j++){
		for(i=dye->START;i<dye->END;i+=dye->INTERVAL){
			dye->spec.data[i*dye->Num+j]/=max[j];
		}
	}
}
MapTable DyeGetImg(MSI *msi, Wie *wimat, Dye *dye, Spec *Grass,Table *MinusLog10){

	int i,j,x,y;
	int SX=210,EX=1810;
	int SY=210,EY=1810;
	int PosiINTERVAL=50;
	int DataSize;
	double *simSpec;////XyNg
	simSpec=dvector(0,wimat->WL);


	MapTable HER;

	DataSize=((EX-SX)/PosiINTERVAL+1)*((EY-SY)/PosiINTERVAL+1);//
	
	HER.Dim=dye->Num;

	HER.data=dvector(0,DataSize*HER.Dim);	
	HER.Num=0;

	for(y=SY;y<EY;y+=PosiINTERVAL){
		for(x=SX;x<EX;x+=PosiINTERVAL){
			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat->BAND;j++){
					simSpec[i]+=wimat->mat[i*wimat->BAND+j]*msi->data[y*msi->X*msi->BAND+x*msi->BAND+j];
				}
				simSpec[i]/=Grass->data[i];//KX̓ߗŊ
			}	

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],MinusLog10);
			}

			for(i=0;i<dye->Num;i++){//FfʎZo
				dye->vol[i]=0;
				for(j=wimat->START;j<wimat->END;j+=wimat->INTERVAL){
					dye->vol[i]+=dye->inv[dye->WL*i+j]*simSpec[j];
				}
				HER.data[HER.Num*HER.Dim+i]=dye->vol[i];
			}
			HER.Num++;
		}
	}

	return HER;
	

}

void CalMean(int *MapLabel,int *ClaNum,MapTable *Mtabl){
	
	int i,j,k;

	for(i=0;i<Mtabl->CS;i++){
		for(j=0;j<Mtabl->Dim;j++){
			Mtabl->mean[i*Mtabl->Dim+j]=0;
		}
	}

	for(j=0;j<Mtabl->Dim;j++){
		for(k=0;k<Mtabl->Num;k++){
			Mtabl->mean[MapLabel[k]*Mtabl->Dim+j]+=Mtabl->data[k*Mtabl->Dim+j];
		}
	}

	for(i=0;i<Mtabl->CS;i++){
		for(j=0;j<Mtabl->Dim;j++){
			Mtabl->mean[i*Mtabl->Dim+j]/=ClaNum[i];
		}
	}

}
double *NucDyebyKmeans(char *fn,int CLASS,Wie *wimat,Dye *dye,Spec *Grass,Table *MinusLog10){

	int i,j,k;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	if(wimat->BAND!=msi.BAND){
		printf("Mistake system matrix for \n%s!!\n",msi.fn);
		printf("Please select correct file. File name is --b.system\n");
		getchar();
		exit(1);
	}

	//////////////////////////////////////////////// kmeans @ɂHFfʂNX^ɕ 
	char fn_CLS[200];
	//int CLASS=4;
	ReName(msi.fn,fn_CLS,"_obkmeans.txt");

	MapTable HER;//HER iamge 
	MapTable H;// H image

	HER=DyeGetImg(&msi,wimat,dye,Grass,MinusLog10);
	
	HER.CS=CLASS;
	HER.mean=dvector(0,HER.CS*HER.Dim);
	HER.ClaNum=ivector(0,HER.CS);

	H.Dim=1;
	H.data=dvector(0,HER.Num*H.Dim);

	for(k=0;k<HER.Num;k++){
		H.data[k]=HER.data[k*HER.Dim+1];// 1 is H
	}
	H=kmeans(H.data,HER.Num,H.Dim,HER.CS);//H image ݂̂kmeans @	
	CalMean(H.MapLabel,H.ClaNum,&HER);// H kmeans 蓾ꂽϒlHER֊i[
	Fwrite_LTABLE(fn_CLS,HER.Num,HER.Dim,H.MapLabel,HER.data);
	
	/////////////////////////////////////////////// j̈̌
	double max;
	int c;
	max=-100000;
	for(i=0;i<HER.CS;i++){
		j=1;//1 is H 
		if(max < HER.mean[i*HER.Dim+j]){
			max=HER.mean[i*HER.Dim+j];
			c=i;
		}
	}
	
	/////////////////////////////////////////////// j̈̕ϐFfʂ蓖Ă
	double *ob_dye;
	ob_dye=dvector(0,dye->Num);

	printf("NUCLEUS DYE\t");
	for(j=0;j<HER.Dim;j++){
		ob_dye[j]=HER.mean[c*HER.Dim+j];
		printf("%f ",ob_dye[j]);
	}
	printf("\n");

	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	return ob_dye;
	
}
void Extractspectral(char *fn_wsig,char *fn_Osig)
{
	int i,j,x,y;
	char *fn_sys="16b.system";

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";
	dye.spec=SpecGet(fn_dye);
	Grass=SpecGet(fn_grass);
	dye.Num=dye.spec.Num;
	dye.WL=dye.spec.WL;
	dye.inv=dvector(0,dye.Num*dye.WL);
	dye.vol=dvector(0,dye.Num);
	dye.INTERVAL=wimat.INTERVAL;
	dye.START=wimat.START;
	dye.END=wimat.END;

	dye.ChagSpec=dvector(0,wimat.WL);//XyNg
	dye.ResiSpec=dvector(0,wimat.WL);//cXyNg
	dye.LBSpec=dvector(0,wimat.WL);//LBŕ\Ƃ\ȓߗ

	//Loge[uPowe[u쐬
	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	for(i=0;i<dye.WL;i++){
		for(j=0;j<dye.Num;j++){
			Do_MinusLog10(&dye.spec.data[i*dye.Num+j],&MinusLog10);
		}
	}

	NormalizeDyespec(&dye);//zx̍ől1ɂ

	double *tempdata,*tpinv;
	int UseDim=int((dye.END-dye.START)/dye.INTERVAL+1);
	tempdata=dvector(0,UseDim*dye.Num);
	tpinv=dvector(0,dye.Num*UseDim);

	for(j=0;j<dye.Num;j++){
		for(i=dye.START;i<dye.END;i+=dye.INTERVAL){
			tempdata[((i-dye.START)/dye.INTERVAL)*dye.Num+j]=dye.spec.data[i*dye.Num+j];
		}
	}

	svdinv_zeromat1D(tempdata,tpinv,UseDim,dye.Num);//[ts̍쐬

	for(j=0;j<dye.Num;j++){
		for(i=0;i<dye.WL;i++){
			dye.inv[j*dye.WL+i]=0;
		}
	}

	for(j=0;j<dye.Num;j++){
		for(i=0;i<UseDim;i++){
			dye.inv[j*dye.WL+i*dye.INTERVAL+dye.START]=tpinv[j*UseDim+i];
		}
	}
	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);
	
	int CLASS=4;
	double *ob_dye;
	double *re_dye;
	ob_dye=dvector(0,dye.Num);
	re_dye=dvector(0,dye.Num);

	double DyeCof[3];

	DyeCof[0]=1.0;
	DyeCof[1]=1.0;//3.809716599; //hematoxylin
	DyeCof[2]=1.0;//6.869876285; //Eosin


	int SX=200,EX=1800;
	int SY=200,EY=1800;
	int PosiINTERVAL=30;

	char fn_rtxt[200];

	ReName(msi.fn,fn_rtxt,"_SpecAndDye.txt");

	FILE *fp;
	printf("%s",fn_rtxt);

	
	if((fp = fopen(fn_rtxt, "w")) == NULL ) {
		printf("%s I[vG[\n",fn_rtxt);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y+=PosiINTERVAL){
		for(x=SX;x<EX;x+=PosiINTERVAL){
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat.BAND;j++){
					simSpec[i]+=wimat.mat[i*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
				simSpec[i]/=Grass.data[i];//KX̓ߗŊ
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
				fprintf(fp,"%.4f\t",simSpec[i]);
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],&MinusLog10);
			}

			for(i=0;i<dye.Num;i++){//FfʎZo
				dye.vol[i]=0;
				for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
					dye.vol[i]+=dye.inv[dye.WL*i+j]*simSpec[j];
				}
			}
			for(i=0;i<dye.Num;i++){
				fprintf(fp,"%f\t",dye.vol[i]);
			}
			fprintf(fp,"\n");

		}

	}

	fclose(fp);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);

	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

Dye Do_Dmat(char *fn_dye,Wie *wimat,Table *MinusLog10)
{
	int i,j;
	Dye dye;
	dye.spec=SpecGet(fn_dye);

	dye.Num=dye.spec.Num;
	dye.WL=dye.spec.WL;
	dye.inv=dvector(0,dye.Num*dye.WL);
	dye.vol=dvector(0,dye.Num);
	dye.INTERVAL=wimat->INTERVAL;
	dye.START=wimat->START;
	dye.END=wimat->END;

	dye.ChagSpec=dvector(0,wimat->WL);//XyNg
	dye.ResiSpec=dvector(0,wimat->WL);//cXyNg
	dye.LBSpec=dvector(0,wimat->WL);//LBŕ\Ƃ\ȓߗ

	for(i=0;i<dye.WL;i++){
		for(j=0;j<dye.Num;j++){
			Do_MinusLog10(&dye.spec.data[i*dye.Num+j],MinusLog10);
		}
	}

	NormalizeDyespec(&dye);//zx̍ől1ɂ

	double *tempdata,*tpinv;
	int UseDim;//

	if(dye.INTERVAL==1){
			UseDim=int((dye.END-dye.START)/dye.INTERVAL);
	}else{
			UseDim=int((dye.END-dye.START)/dye.INTERVAL)+1;
	}




	tempdata=dvector(0,UseDim*dye.Num);
	tpinv=dvector(0,dye.Num*UseDim);

	for(j=0;j<dye.Num;j++){
		for(i=dye.START;i<dye.END;i+=dye.INTERVAL){
			tempdata[((i-dye.START)/dye.INTERVAL)*dye.Num+j]=dye.spec.data[i*dye.Num+j];
		}
	}

	svdinv_zeromat1D(tempdata,tpinv,UseDim,dye.Num);//[ts̍쐬

	for(j=0;j<dye.Num;j++){
		for(i=0;i<dye.WL;i++){
			dye.inv[j*dye.WL+i]=0;
		}
	}

	for(j=0;j<dye.Num;j++){
		for(i=0;i<UseDim;i++){
			dye.inv[j*dye.WL+i*dye.INTERVAL+dye.START]=tpinv[j*UseDim+i];
		}
	}

	free_dvector(tempdata,0,UseDim*dye.Num);
	free_dvector(tpinv,0,dye.Num*UseDim);


	return dye;

}

void GetEstTrans(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_ROI)
{
	int i,j,k,x,y,n;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Fwrite_NVmat("test.xls",&wimat,wimat.mat);

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";//have to be 401 dim
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";//have to be 401 dim

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml
	double *dg;

	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);
	dg=dvector(0,wimat.BAND);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);


	char fnw[200];
	char fnd[200];

	ReName(fn_ROI,fnw,"_est.spec");
	ReName(fn_ROI,fnd,"_dye.txt");
//	ReName(msi.fn,fnw,fnc);

	ROI roi;
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("test.xls",&roi);

	FILE *fp,*fp2;
	printf("%s\n",fnw);
	char *fntmp="temporary.txt";
	
	if((fp = fopen(fnw, "w")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}
	if((fp2 = fopen(fnd, "w")) == NULL ) {
		printf("%s I[vG[\n",fnd);
		getchar();
		exit(1);
	}
	
	printf("SPEC\t");
	printf("DYE\t");
	printf("LBSPEC\t");
	printf("RESI\n");
		
	fprintf(fp,"\t");
	for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			fprintf(fp,"spe%d\t",i+1);
	}
	fprintf(fp,"\n");

	fprintf(fp2,"\t");
	for(i=0;i<dye.Num;i++){//FfʎZo
		fprintf(fp2,"DYE%d\t",i+1);
	}
	fprintf(fp2,"\n");



	for(n=0;n<roi.Num;n++){//ROI̐for[v
		for(j=0;j<wimat.BAND;j++){
			dg[j]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
					dg[j]+=msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			dg[j]/=roi.AREA[n];// roi.AREA[j] @roi.AREA[n]ƎvH
		}

		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
			simSpec[i]=0;
			for(j=0;j<wimat.BAND;j++){
				simSpec[i]+=wimat.mat[i*wimat.BAND+j]*dg[j];
			}
			simSpec[i]/=Grass.data[i];//KX̓ߗŊ
		
		}	

		fprintf(fp,"ORI\t");

		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
			Do_MinusLog10(&simSpec[i],&MinusLog10);
			fprintf(fp,"%f\t",simSpec[i]);
		}
		fprintf(fp,"\n");

		for(i=0;i<dye.Num;i++){//FfʎZo
			dye.vol[i]=0;
			for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
				dye.vol[i]+=dye.inv[dye.WL*i+j]*simSpec[j];
			}
			fprintf(fp2,"%f\t",dye.vol[i]);
		}
		fprintf(fp2,"\n");
	
		fprintf(fp,"LB\t");
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
			dye.LBSpec[i]=0;
			for(j=0;j<dye.Num;j++){
				dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
			}
			fprintf(fp,"%f\t",dye.LBSpec[i]);
		}
		fprintf(fp,"\n");
		

		fprintf(fp,"RESI\t");
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
			dye.ResiSpec[i]=simSpec[i]-dye.LBSpec[i];
			fprintf(fp,"%f\t",dye.ResiSpec[i]);
		}
		fprintf(fp,"\n");
		

		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//ߗ֕ϊ
			Do_Minus10Power(&simSpec[i],&Minus10Power);
			simSpec[i]*=Grass.data[i];//KX̓ߗ
		}

		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			xyz[k]=0;
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
				xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k]*simSpec[i];
			}
		}

		for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
			irgb[k]=0;
			for(j=0;j<xyzfunc.Num;j++){
				irgb[k]+=dsp.XtoD[k*xyzfunc.Num+j]*xyz[j];
			}
		}

		RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml

	}
	fclose(fp);
	fclose(fp2);

//	Fwrite_TF(fnw,roi.Num*3,(wimat.END-wimat.START)/wimat.INTERVAL);


	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

CBar GetColorBar8(void){

	CBar Cb;
	Cb.LEVEL=8;
	int rgb=3,i,j;
	Cb.Sig=ucvector(0,rgb*Cb.LEVEL);

	unsigned char Sig[]={	
	
			
			0,0,255,//
			0,125,255,//F
			255,255,0,//F
			125,255,0,//
			0,125,0,//
			255,0,125,//F
			255,0,255,//sN
			255,0,0 //
	};


	for(i=0;i<Cb.LEVEL;i++){
		for(j=0;j<rgb;j++){
		Cb.Sig[i*rgb+j]=Sig[i*rgb+j];
		}
	}

	return Cb;

}

CBar GetColorBar7(void){

	CBar Cb;
	Cb.LEVEL=7;
	int rgb=3,i,j;
	Cb.Sig=ucvector(0,rgb*Cb.LEVEL);

	unsigned char Sig[]={	
	
			
			0,0,255,//
			0,125,255,//F
			255,255,0,//F
			125,255,0,//
			0,125,0,//
			255,0,125,//F
			255,0,0 //
	};


	for(i=0;i<Cb.LEVEL;i++){
		for(j=0;j<rgb;j++){
		Cb.Sig[i*rgb+j]=Sig[i*rgb+j];
		}
	}

	return Cb;

}

CBar GetColorBarMiyazawa6(void){

	CBar Cb;
	Cb.LEVEL=6;
	int rgb=3,i,j;
	Cb.Sig=ucvector(0,rgb*Cb.LEVEL);

	unsigned char Sig[]={	
	
			
			//0,0,255,//
			//0,125,255,//F
			//255,255,0,//F
			//125,255,0,//
			//0,125,0,//
			//255,0,125,//F

			0,0,255,//j@								
			255,0,255,//		 A׊ǂ̍זE@		sN
			255,255,0,//@			TME@	F
			255,0,0,//Ԍ@							
			0,255,0,//collagen			ہ@			
			255,255,255//KX@						

//			255,0,255,//זE@sN
			


	};


	for(i=0;i<Cb.LEVEL;i++){
		for(j=0;j<rgb;j++){
		Cb.Sig[i*rgb+j]=Sig[i*rgb+j];
		}
	}

	return Cb;

}

CBar GetColorBar4(void){

	CBar Cb;
	Cb.LEVEL=4;
	int rgb=3,i,j;
	Cb.Sig=ucvector(0,rgb*Cb.LEVEL);

	unsigned char Sig[]={	
			0,0,255,//
			0,255,0,//
			255,0,255,//
			255,0,0 //
	};


	for(i=0;i<Cb.LEVEL;i++){
		for(j=0;j<rgb;j++){
		Cb.Sig[i*rgb+j]=Sig[i*rgb+j];
		}
	}

	return Cb;

}

CBar GetColorBar5(void){

	CBar Cb;
	Cb.LEVEL=5;
	int rgb=3,i,j;
	Cb.Sig=ucvector(0,rgb*Cb.LEVEL);

	unsigned char Sig[]={	
			0,0,0, //
			0,0,180,//
			0,200,0,//
			225,225,0,//
			255,0,0 //
			
	};


	for(i=0;i<Cb.LEVEL;i++){
		for(j=0;j<rgb;j++){
		Cb.Sig[i*rgb+j]=Sig[i*rgb+j];
		}
	}

	return Cb;

}


void Resi_NSEImg(char *fn_sys,char *fn_wsig,char *fn_Osig)
{
	int i,j,x,y;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);
	
	int SX=200,EX=1800;
	int SY=200,EY=1800;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_resi[200];
	double Rpower,Opower,NSE;

	ReName(msi.fn,fn_resi,"_resi.raw");

	FILE *fp;
	printf("%s",fn_resi);
	
	if((fp = fopen(fn_resi, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_resi);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat.BAND;j++){
					simSpec[i]+=wimat.mat[i*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
				simSpec[i]/=Grass.data[i];//KX̓ߗŊ
			}	

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],&MinusLog10);
			}

			for(i=0;i<dye.Num;i++){//FfʎZo
				dye.vol[i]=0;
				for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
					dye.vol[i]+=dye.inv[dye.WL*i+j]*simSpec[j];
				}
			}

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.LBSpec[i]=0;
				for(j=0;j<dye.Num;j++){
					dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
				}
			}
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				dye.ResiSpec[i]=simSpec[i]-dye.LBSpec[i];
			}

			Rpower=0;
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				Rpower+=dye.ResiSpec[i]*dye.ResiSpec[i];
			}
			Opower=0;
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
				Opower+=simSpec[i]*simSpec[i];
			}
			NSE=Rpower/Opower;

			fwrite(&NSE,sizeof(double),1,fp);

		}

	}

	fclose(fp);	
	printf("\nResidual spectral image is generated !!\n");
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);

	free_dvector(simSpec,0,wimat.WL);

}


void ROI_Error_Spect_Dye_LAB_16Dim(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16,char *fn_ROI)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	//char fn_dye16[]="NormalizedResiPC1_R(no)_HE_upmc16ODsignalfrom401dim.spec";
	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//XyNg덷
	double Rpower,Opower,NSE;
	double All_Rpower,All_Opower,NMSE;
			

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz,*xyz_LB;//XYZl

	xyz=dvector(0,xyzfunc.Num);
	xyz_LB=dvector(0,xyzfunc.Num);
	
	double *lab,*lab_LB;//LABl
	double E,All_E;//F
	lab=dvector(0,xyzfunc.Num);
	lab_LB=dvector(0,xyzfunc.Num);

	double *whi_xyz;//XYZOhl
	whi_xyz=dvector(0,xyzfunc.Num);	

	for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
		whi_xyz[k]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			whi_xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k];
		}
	}

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	
	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fnw[200],name_sp[200];
	char fnd[200],name_dye[200];
	char fnl[200],name_lab[200];
	char fnm[200],name_error[200];

	sprintf(name_sp,"_Est_Dye%d.spec",dye16.Num);
	sprintf(name_dye,"_Dye%d.txt",dye16.Num);
	sprintf(name_lab,"_Lab_Dye%d.txt",dye16.Num);
	sprintf(name_error,"_Err_Dye%d.txt",dye16.Num);

	ReName(fn_ROI,fnw,name_sp);
	ReName(fn_ROI,fnd,name_dye);
	ReName(fn_ROI,fnl,name_lab);
	ReName(fn_ROI,fnm,name_error);


	ROI roi;
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("Check_ROIdata.xls",&roi);

	FILE *fp,*fp2,*fp3,*fp4;

	double *dg;
	dg=dvector(0,wimat.BAND);//ϐMl
	
	if((fp = fopen(fnw, "w")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}
	if((fp2 = fopen(fnd, "w")) == NULL ) {
		printf("%s I[vG[\n",fnd);
		getchar();
		exit(1);
	}

	if((fp3 = fopen(fnl, "w")) == NULL ) {
		printf("%s I[vG[\n",fnl);
		getchar();
		exit(1);
	}
	
	if((fp4 = fopen(fnm, "w")) == NULL ) {
		printf("%s I[vG[\n",fnm);
		getchar();
		exit(1);
	}
	
	printf("SPEC\t");
	printf("DYE\t");
	printf("LBSPEC\t");
	printf("RESI\t");
	printf("LAB\t");
	printf("Error\t");

	fprintf(fp,"\t");
	for(i=0;i<wimat.BAND;i++){
			fprintf(fp,"spe%d\t",i+1);
	}
	fprintf(fp,"\n");

	fprintf(fp2,"\t");
	for(i=0;i<dye16.Num;i++){//FfʎZo
		fprintf(fp2,"DYE%d\t",i+1);
	}
	fprintf(fp2,"\n");

	fprintf(fp3,"\t");
	for(i=0;i<xyzfunc.Num;i++){//FfʎZo
		fprintf(fp3,"Ori_Lab%d\t",i+1);
	}
	for(i=0;i<xyzfunc.Num;i++){//FfʎZo
		fprintf(fp3,"LB_Lab%d\t",i+1);
	}
	fprintf(fp3,"\n");

	fprintf(fp4,"\tE*\tNMSE\n");
	

	All_Rpower=0;
	All_Opower=0;
	All_E=0;
	
	for(int n=0;n<roi.Num;n++){//ROI̐for[v

		for(j=0;j<wimat.BAND;j++){
			dg[j]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
					dg[j]+=msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			dg[j]/=roi.AREA[n];
		}

		///////////////////////////////////16ԂŒ@Jn/////////////////////////

		for(i=0;i<wimat.BAND;i++){//ߗMlZo
			spec16[i]=dg[i]/wg[i];
		}

		for(i=0;i<wimat.BAND;i++){//zx֕ϊ
			Do_MinusLog10(&spec16[i],&MinusLog10);
		}
		fprintf(fp,"ORI\t");
		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
			spec16[i]-=Grass16.data[i];
			fprintf(fp,"%f\t",spec16[i]);
		}
		fprintf(fp,"\n");

		fprintf(fp2,"DYE\t");
		for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
			dye16.vol[j]=0;
			for(i=0;i<dye16.WL;i++){
				dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
			}
			fprintf(fp2,"%f\t",dye16.vol[j]);
		}
		fprintf(fp2,"\n");

		fprintf(fp,"LB\t");
		for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
			dye16.LBSpec[i]=0;
			for(j=0;j<dye16.Num;j++){
				dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
			}
			fprintf(fp,"%f\t",dye16.LBSpec[i]);
		}
		fprintf(fp,"\n");

		fprintf(fp,"RESI\t");
		for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
			dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			fprintf(fp,"%f\t",dye16.ResiSpec[i]);
		}
		fprintf(fp,"\n");

		for(i=0;i<dye16.WL;i++){//Wzx O.K. 07/05/22
			dye16.ChagSpec[i]=dye16.ResiSpec[i]+dye16.LBSpec[i];
		}
		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
			dye16.ChagSpec[i]+=Grass16.data[i];//̃XyNg
			dye16.LBSpec[i]+=Grass16.data[i];//Ffŕ\XyNg
		}
		for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
			Do_Minus10Power(&dye16.ChagSpec[i],&Minus10Power);
			Do_Minus10Power(&dye16.LBSpec[i],&Minus10Power);
		}

		/// *************        Normalized Square Error                ******************
		Rpower=0;
		Opower=0;
		for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
			Rpower+=dye16.ResiSpec[i]*dye16.ResiSpec[i];
			Opower+=dye16.ChagSpec[i]*dye16.ChagSpec[i];
		}
		NSE=Rpower/Opower;//e_ɂ덷
		All_Rpower+=Rpower;
		All_Opower+=Opower;

		/// *************         ̓ߗ狁߂L*a*b*@                ******************
		for(k=0;k<xyzfunc.Num;k++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
			xyz[k]=0;
			for(i=0;i<wimat.BAND;i++){
				xyz[k]+=StoX[k*wimat.BAND+i]*dye16.ChagSpec[i]*wg[i];
			}
		}
		XYZtoLAB(xyz,whi_xyz,lab);
		/// *************         LBŕ\ߗ狁߂L*a*b*@                ******************
		for(k=0;k<xyzfunc.Num;k++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
			xyz_LB[k]=0;
			for(i=0;i<wimat.BAND;i++){
				xyz_LB[k]+=StoX[k*wimat.BAND+i]*dye16.LBSpec[i]*wg[i];
			}
		}
		XYZtoLAB(xyz_LB,whi_xyz,lab_LB);

		E=0;//F
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
				E+=(lab[k]-lab_LB[k])*(lab[k]-lab_LB[k]);			
		}	
		E=sqrt(E);
		All_E+=E;

		/// *************         L*a*b*l̏o@                ******************
		fprintf(fp3,"Lab\t");
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			fprintf(fp3,"%f\t",lab[k]);
		}
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			fprintf(fp3,"%f\t",lab_LB[k]);
		}
		fprintf(fp3,"\n");//Fo

		// ***************************   덷̏o     
		fprintf(fp4,"DATA%d\t",n);
		fprintf(fp4,"%f\t%f\n",E,NSE);//Fo
		

	}

	NMSE=All_Rpower/All_Opower;
	All_E/=roi.Num;

	// ***************************   덷̏o     
	fprintf(fp4,"AVERAGE\t%f\t%f\n",All_E,NMSE);//Fo

	fclose(fp);
	fclose(fp2);
	fclose(fp3);
	fclose(fp4);
	

	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);

	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void ROI_Error_Spect_Dye_LAB_16Dim(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16,char *fn_ROI,char *WFileName)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	//char fn_dye16[]="NormalizedResiPC1_R(no)_HE_upmc16ODsignalfrom401dim.spec";
	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//ϐFf
	double *ave_dye;
	ave_dye=dvector(0,dye16.Num);

	//XyNg덷 cXyNg֘A
	double Rpower,Opower,NSE;
	double All_Rpower,All_Opower,NMSE;
	double *Ave_Resi,*Ave_Ori,*Ave_LB;//ߗ
	double *Ave_OD_Resi,*Ave_OD_Ori,*Ave_OD_LB;//zx

	//************* ߗ ***********************
	Ave_Ori=dvector(0,dye16.WL);//σXyNg
	Ave_LB=dvector(0,dye16.WL);//LBōč\ꂽXyNg
	Ave_Resi=dvector(0,dye16.WL);//ώcXyNg

	//************* zx ***********************
	Ave_OD_Ori=dvector(0,dye16.WL);//σXyNg
	Ave_OD_LB=dvector(0,dye16.WL);//LBōč\ꂽXyNg
	Ave_OD_Resi=dvector(0,dye16.WL);//ώcXyNg


			
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz,*xyz_LB;//XYZl

	xyz=dvector(0,xyzfunc.Num);
	xyz_LB=dvector(0,xyzfunc.Num);
	
	double *lab,*lab_LB;//LABl
	double *Ave_Lab,*Ave_Lab_LB;
	double E,All_E;//F
	lab=dvector(0,xyzfunc.Num);
	lab_LB=dvector(0,xyzfunc.Num);
	Ave_Lab=dvector(0,xyzfunc.Num);
	Ave_Lab_LB=dvector(0,xyzfunc.Num);

	double *whi_xyz;//XYZOhl
	whi_xyz=dvector(0,xyzfunc.Num);	

	for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
		whi_xyz[k]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			whi_xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k];
		}
	}

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	
	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fnw[200],name_sp[200];
	char fnd[200],name_dye[200];
	char fnl[200],name_lab[200];
	char fnm[200],name_error[200];
	char fna[200],name_ave[200];
	char fn_Alab[200],name_Avelab[200];//L*a*b*
	char fn_Resi[200],name_AveResi[200];// spectral transmittance 
	char fn_OD_Resi[200],name_AveOD_Resi[200];// spectral transmittance 



	sprintf(name_sp,"_Est_Dye%d.spec",dye16.Num);
	sprintf(name_dye,"_Dye%d.txt",dye16.Num);
	sprintf(name_lab,"_Lab_Dye%d.txt",dye16.Num);
	sprintf(name_error,"_Err_Dye%d.txt",dye16.Num);
	sprintf(name_ave,"_ave_Dye%d.txt",dye16.Num);
	sprintf(name_Avelab,"_ave_Lab_Dye%d.txt",dye16.Num);
	sprintf(name_AveResi,"_ave_trans_Dye%d.spec",dye16.Num);
	sprintf(name_AveOD_Resi,"_ave_OD_Dye%d.spec",dye16.Num);

	ReName(WFileName,fnw,name_sp);
	ReName(WFileName,fnd,name_dye);
	ReName(WFileName,fnl,name_lab);
	ReName(WFileName,fnm,name_error);
	ReName(WFileName,fna,name_ave);

	ReName(WFileName,fn_Alab,name_Avelab);//ρ@l*a*b*l	
	ReName(WFileName,fn_Resi,name_AveResi);//ρ@cXyNg@ߗ
	ReName(WFileName,fn_OD_Resi,name_AveOD_Resi);//ρ@cXyNg zx


	ROI roi;
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("Check_ROIdata.xls",&roi);

	FILE *fp,*fp2,*fp3,*fp4,*fp5;
	FILE *fp_l,*fp_re,*fp_o;

	double *dg;
	dg=dvector(0,wimat.BAND);//ϐMl
	
	if((fp = fopen(fnw, "aw")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}
	if((fp2 = fopen(fnd, "aw")) == NULL ) {
		printf("%s I[vG[\n",fnd);
		getchar();
		exit(1);
	}

	if((fp3 = fopen(fnl, "aw")) == NULL ) {
		printf("%s I[vG[\n",fnl);
		getchar();
		exit(1);
	}
	
	if((fp4 = fopen(fnm, "aw")) == NULL ) {
		printf("%s I[vG[\n",fnm);
		getchar();
		exit(1);
	}

	if((fp5 = fopen(fna, "aw")) == NULL ) {
		printf("%s I[vG[\n",fna);
		getchar();
		exit(1);
	}

	if((fp_l = fopen(fn_Alab, "aw")) == NULL ) {
		printf("%s I[vG[\n",fn_Alab);
		getchar();
		exit(1);
	}

	if((fp_re = fopen(fn_Resi, "aw")) == NULL ) {
		printf("%s I[vG[\n",fn_Resi);
		getchar();
		exit(1);
	}

	if((fp_o = fopen(fn_OD_Resi, "aw")) == NULL ) {
		printf("%s I[vG[\n",fn_OD_Resi);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@Cʒu = %ld\n",ftell(fp));

	if(ftell(fp)==0){

		fprintf(fp,"FileName\tDATA\t");
		for(i=0;i<wimat.BAND;i++){
			fprintf(fp,"spe%d\t",i+1);
		}
		fprintf(fp,"\n");

		fprintf(fp2,"FileName\tDATA\t");
		for(i=0;i<dye16.Num;i++){//FfʎZo
			fprintf(fp2,"DYE%d\t",i+1);
		}
		fprintf(fp2,"\n");

		fprintf(fp3,"FileName\tDATA\t");
		for(i=0;i<xyzfunc.Num;i++){//FfʎZo
			fprintf(fp3,"Ori_Lab%d\t",i+1);
		}
		for(i=0;i<xyzfunc.Num;i++){//FfʎZo
			fprintf(fp3,"LB_Lab%d\t",i+1);
		}
		fprintf(fp3,"\n");

		fprintf(fp4,"FileName\tDATA\tE*\tNMSE\n");

		fprintf(fp5,"FileName\tE*\tNMSE\t");

		for(i=0;i<dye16.Num;i++){//FfʎZo
			fprintf(fp5,"ave_DYE%d\t",i+1);
		}
		fprintf(fp5,"\n");

		//L*a*b*l
		fprintf(fp_l,"FileName\tave_L*\ttave_a*\ttave_b*\t");
		fprintf(fp_l,"ave_L*_LB\tave_a*_LB\tave_b*_LB\n");
		

		//ώcXyNg̎Zo  ߗ
		fprintf(fp_re,"FileName\tDATA\t");
		for(i=0;i<wimat.BAND;i++){
			fprintf(fp_re,"spe%d\t",i+1);
		}
		fprintf(fp_re,"\n");

		//ώcXyNg̎Zo  zx
		fprintf(fp_o,"FileName\tDATA\t");
		for(i=0;i<wimat.BAND;i++){
			fprintf(fp_o,"spe%d\t",i+1);
		}
		fprintf(fp_o,"\n");

	}else{

		fprintf(fp,"\n");
		fprintf(fp2,"\n");
		fprintf(fp3,"\n");
		fprintf(fp4,"\n");
	//	fprintf(fp5,"\n");

	}

	fseek(fp,  0L, SEEK_SET);
//	printf("t@Cʒu = %ld\n",ftell(fp));

//****************         @**************************************
	All_Rpower=0;
	All_Opower=0;
	All_E=0;

	for(j=0;j<dye16.Num;j++){//Ff
			ave_dye[j]=0;
	}

	for(j=0;j<xyzfunc.Num;j++){//Ff
			Ave_Lab[j]=0;
			Ave_Lab_LB[j]=0;
	}

	for(i=0;i<dye16.WL;i++){//residual in transmittance space
		Ave_LB[i]=0;
		Ave_Ori[i]=0;
		Ave_Resi[i]=0;
	}

	for(i=0;i<dye16.WL;i++){//residual in optical density space
		Ave_OD_LB[i]=0;
		Ave_OD_Ori[i]=0;
		Ave_OD_Resi[i]=0;
	}


//*******************       [vJn@**************************************	
	for(int n=0;n<roi.Num;n++){//ROI̐for[v

		for(j=0;j<wimat.BAND;j++){
			dg[j]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
					dg[j]+=msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			dg[j]/=roi.AREA[n];
		}

		///////////////////////////////////16ԂŒ@Jn/////////////////////////

		for(i=0;i<wimat.BAND;i++){//ߗMlZo
			spec16[i]=dg[i]/wg[i];
		}

		for(i=0;i<wimat.BAND;i++){//zx֕ϊ
			Do_MinusLog10(&spec16[i],&MinusLog10);
		}
		fprintf(fp,"%s\tORI",fn_ROI);
		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
			spec16[i]-=Grass16.data[i];
			fprintf(fp,"\t%f",spec16[i]);
		}
		fprintf(fp,"\n");

		fprintf(fp2,"%s\tDYE",fn_ROI);
		for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
			dye16.vol[j]=0;
			for(i=0;i<dye16.WL;i++){
				dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
			}
			fprintf(fp2,"\t%f",dye16.vol[j]);
			ave_dye[j]+=dye16.vol[j];
		}
		fprintf(fp2,"\n");

		fprintf(fp,"%s\tLB",fn_ROI);
		for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
			dye16.LBSpec[i]=0;
			for(j=0;j<dye16.Num;j++){
				dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
			}
			fprintf(fp,"\t%f",dye16.LBSpec[i]);
		}
		fprintf(fp,"\n");

		fprintf(fp,"%s\tRESI",fn_ROI);
		for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
			dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			fprintf(fp,"\t%f",dye16.ResiSpec[i]);
		}
		fprintf(fp,"\n");

		for(i=0;i<dye16.WL;i++){//c𑫂zx O.K. 07/05/22
			dye16.ChagSpec[i]=dye16.ResiSpec[i]+dye16.LBSpec[i];
		}
		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
			dye16.ChagSpec[i]+=Grass16.data[i];//̃XyNg
			dye16.LBSpec[i]+=Grass16.data[i];//Ffŕ\XyNg
		}

		//*******************   Averaged original and LB and residual in optical density space ***********************
		for(i=0;i<dye16.WL;i++){
			Ave_OD_Ori[i]+=dye16.ChagSpec[i];
			Ave_OD_LB[i]+=dye16.LBSpec[i];
			Ave_OD_Resi[i]+=dye16.ResiSpec[i];
		}
		//*****************************************************************************


		for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
			Do_Minus10Power(&dye16.ChagSpec[i],&Minus10Power);
			Do_Minus10Power(&dye16.LBSpec[i],&Minus10Power);
		}

		/// *************        Normalized Square Error  in transmittance space   ******************

		for(i=0;i<dye16.WL;i++){//residual in transmittance space
			dye16.ResiSpec[i]=dye16.ChagSpec[i]-dye16.LBSpec[i];
			Ave_Ori[i]+=dye16.ChagSpec[i];
			Ave_LB[i]+=dye16.LBSpec[i];
			Ave_Resi[i]+=dye16.ResiSpec[i];
		}

		Rpower=0;
		Opower=0;
		for(i=0;i<dye16.WL;i++){//
			Rpower+=dye16.ResiSpec[i]*dye16.ResiSpec[i];
			Opower+=dye16.ChagSpec[i]*dye16.ChagSpec[i];
		}
		NSE=Rpower/Opower;//e_ɂ덷
		All_Rpower+=Rpower;
		All_Opower+=Opower;

		/// *************         ̓ߗ狁߂L*a*b*@                ******************
		for(k=0;k<xyzfunc.Num;k++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
			xyz[k]=0;
			for(i=0;i<wimat.BAND;i++){
				xyz[k]+=StoX[k*wimat.BAND+i]*dye16.ChagSpec[i]*wg[i];
			}
		}
		XYZtoLAB(xyz,whi_xyz,lab);
		/// *************         LBŕ\ߗ狁߂L*a*b*@                ******************
		for(k=0;k<xyzfunc.Num;k++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
			xyz_LB[k]=0;
			for(i=0;i<wimat.BAND;i++){
				xyz_LB[k]+=StoX[k*wimat.BAND+i]*dye16.LBSpec[i]*wg[i];
			}
		}
		XYZtoLAB(xyz_LB,whi_xyz,lab_LB);

		E=0;//F
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
				E+=(lab[k]-lab_LB[k])*(lab[k]-lab_LB[k]);
				Ave_Lab[k]+=lab[k];
				Ave_Lab_LB[k]+=lab_LB[k];
		}	
		E=sqrt(E);
		All_E+=E;

		/// *************         L*a*b*l̏o@                ******************
		fprintf(fp3,"%s\tLab",fn_ROI);
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			fprintf(fp3,"\t%f",lab[k]);
		}
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			fprintf(fp3,"\t%f",lab_LB[k]);
		}
		fprintf(fp3,"\n");//Fo

		// ***************************   덷̏o     
		fprintf(fp4,"%s\tDATA%d\t",fn_ROI,n);
		fprintf(fp4,"%f\t%f\n",E,NSE);//Fo
		

	}

	NMSE=All_Rpower/All_Opower;
	All_E/=roi.Num;

	// ***************************   덷̏o     ***********************************
	fprintf(fp5,"%s\t%f\t%f",fn_ROI,All_E,NMSE);//Fo
	for(j=0;j<dye16.Num;j++){//Ff
			ave_dye[j]/=roi.Num;
			fprintf(fp5,"\t%f",ave_dye[j]);
	}
	fprintf(fp5,"\n");

	
	// ***************************   cXyNg̏o   ߗ  ***********************************
	fprintf(fp_re,"%s\tOri",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_Ori[j]/=roi.Num;
		fprintf(fp_re,"\t%f",Ave_Ori[j]);
	}
	fprintf(fp_re,"\n");

	fprintf(fp_re,"%s\tLB",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_LB[j]/=roi.Num;
		fprintf(fp_re,"\t%f",Ave_LB[j]);
	}
	fprintf(fp_re,"\n");

	fprintf(fp_re,"%s\tResi",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_Resi[j]/=roi.Num;
		fprintf(fp_re,"\t%f",Ave_Resi[j]);
	}
	fprintf(fp_re,"\n");

	// ***************************   cXyNg̏o   zx  ***********************************
	fprintf(fp_o,"%s\tOri",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_OD_Ori[j]/=roi.Num;
		fprintf(fp_o,"\t%f",Ave_OD_Ori[j]);
	}
	fprintf(fp_o,"\n");

	fprintf(fp_o,"%s\tLB",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_OD_LB[j]/=roi.Num;
		fprintf(fp_o,"\t%f",Ave_OD_LB[j]);
	}
	fprintf(fp_o,"\n");

	fprintf(fp_o,"%s\tResi",fn_ROI);//o
	for(j=0;j<dye16.WL;j++){//
		Ave_OD_Resi[j]/=roi.Num;
		fprintf(fp_o,"\t%f",Ave_OD_Resi[j]);
	}
	fprintf(fp_o,"\n");


	
	// ***************************   L*a*b*l̏o     ***********************************
	fprintf(fp_l,"%s",fn_ROI);//Fo

	for(k=0;k<xyzfunc.Num;k++){//
				Ave_Lab[k]/=roi.Num;
				fprintf(fp_l,"\t%f",Ave_Lab[k]);//o

	}

	for(k=0;k<xyzfunc.Num;k++){//
		Ave_Lab_LB[k]/=roi.Num;
		fprintf(fp_l,"\t%f",Ave_Lab_LB[k]);//o

	}

	fprintf(fp_l,"\n");//o


	

	fclose(fp);
	fclose(fp2);
	fclose(fp3);
	fclose(fp4);
	fclose(fp5);

	fclose(fp_l);
	fclose(fp_re);
	fclose(fp_o);
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);

	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void DoubletoShort(char *fn,double omax,double omin)
{
	FILE *fp;
	double *data;
	double dg;
	int SIZE,Num;
	double max=-10000,min=1000;
	unsigned short int sg;
	int i;
	char fnw[200];

	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	SIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);

	Num=(int)SIZE/(sizeof(double));//f
	data=dvector(0,Num);

	fread(data,sizeof(double),Num,fp);
	fclose(fp);

	printf("Number of data=%d\n",Num);

	dg=0;
	for(i=0;i<Num;i++){//摜̍őlƍŏl
		if(data[i]>max)max=data[i];
		if(data[i]<min)min=data[i];
		dg+=data[i];
	}
	dg/=Num;

	ReName(fn,fnw,"_simg.raw");
	printf("Image is %s\nmax=%f\tmin=%f\taverage=%f\n",fn,max,min,dg);
	printf("Output Image is %s\nomax=%f\tomin=%f\n",fnw,omax,omin);

	if((fp = fopen(fnw, "wb")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}


	for(i=0;i<Num;i++){


		dg=(data[i]-omin)/(omax-omin);
		if(data[i]>omax)dg=omax;
		if(data[i]<omin)dg=omin;

		dg*=pow((double)(256),(double)(sizeof(unsigned short int)));
		sg=(unsigned short int)dg;
		
		fwrite(&sg,sizeof(unsigned short int ),1,fp);

	}

	fclose(fp);


}

void DoubletoChar(char *fn,double omax,double omin)
{
	FILE *fp;
	double *data;
	double dg;
	int SIZE,Num;
	double max=-10000,min=1000;
	unsigned char cg;
	int i;
	char fnw[200];

	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	SIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);

	Num=(int)SIZE/(sizeof(double));//f
	data=dvector(0,Num);

	fread(data,sizeof(double),Num,fp);
	fclose(fp);

	printf("Number of data=%d\n",Num);

	dg=0;
	for(i=0;i<Num;i++){//摜̍őlƍŏl
		if(data[i]>max)max=data[i];
		if(data[i]<min)min=data[i];
		dg+=data[i];
	}
	dg/=Num;

	//ReName(fn,fnw,"_cimg.raw");

	char name[200];
	sprintf(name,"_%2.2f_%2.2fcimg.raw",omax,omin);
	ReName(fn,fnw,name);

	printf("Image is %s\nmax=%f\tmin=%f\taverage=%f\n",fn,max,min,dg);
	printf("Output Image is %s\nomax=%f\tomin=%f\n",fnw,omax,omin);





	if((fp = fopen(fnw, "wb")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}


	for(i=0;i<Num;i++){


		dg=(data[i]-omin)/(omax-omin);
		dg*=pow((double)256,(double)sizeof(unsigned char));
		dg-=1;

		if(data[i]>omax){
			dg=pow((double)256,(double)sizeof(unsigned char));
			dg-=1;

		}
		if(data[i]<omin){
			dg=1;
		}

	//	dg*=pow(256,sizeof(unsigned short int));
	//	sg=(unsigned short int)dg;

		cg=(unsigned char)dg;

		

/*		if(cg>230){
			printf("%d\n",cg);
			printf("%f\n",data[i]);

		}

*/
		
		fwrite(&cg,sizeof(unsigned char ),1,fp);

	}

	fclose(fp);

	free_dvector(data,0,Num);



}

void DoubletoPseudoImg(char *fn,double omax,double omin,int STEP)
{
	FILE *fp;
	double *data;
	double dg;
	int SIZE,Num;
	double max=-10000,min=1000;
	unsigned char *rgb;
	int BAND=3;
	int i,j;
	char fnw[200];
	double *rang,itval;

	rgb=ucvector(0,BAND);

	CBar Cb;

	if(STEP==8){
		Cb=GetColorBar8();
		
	}else if(STEP==4){
		Cb=GetColorBar4();
		
	}else if(STEP==5){
		Cb=GetColorBar5();
		
	}
	else if(STEP==7){
		Cb=GetColorBar7();
		
	}
	else{
		printf("Not exist color bar %d !!\n",STEP);
		getchar();
		exit(1);
	}

	rang=dvector(0,STEP+1);
	itval=(omax-omin)/STEP;

	rang[0]=omin;
	for(i=0;i<STEP;i++){
		rang[i+1]=itval*(i+1)+omin;
	}

	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	SIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);

	Num=(int)SIZE/(sizeof(double));//f
	data=dvector(0,Num);

	fread(data,sizeof(double),Num,fp);
	fclose(fp);

	printf("Number of data=%d\n",Num);

	dg=0;
	for(i=0;i<Num;i++){//摜̍őlƍŏl
		if(data[i]>max)max=data[i];
		if(data[i]<min)min=data[i];
		dg+=data[i];
	}
	dg/=Num;

//	ReName(fn,fnw,"_cbar.raw");

	char name[200];
	sprintf(name,"_%dcbar%2.2f_%2.2f.raw",STEP,omax,omin);
	ReName(fn,fnw,name);


	printf("Image is %s\nmax=%f\tmin=%f\taverage=%f\n",fn,max,min,dg);
	printf("Output Image is %s\nomax=%f\tomin=%f\n",fnw,omax,omin);

	for(i=0;i<STEP;i++){
		printf("Step%d RANGE%f-%f RGB %d %d %d\n",i,rang[i],rang[i+1],Cb.Sig[i*BAND],Cb.Sig[i*BAND+1],Cb.Sig[i*BAND+2]);
	}


	if((fp = fopen(fnw, "wb")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}


	for(i=0;i<Num;i++){

		if(data[i]<omin){
			rgb[0]=Cb.Sig[0];
			rgb[1]=Cb.Sig[1];
			rgb[2]=Cb.Sig[2];
		}else if(data[i]>omax){
			j=STEP-1;
			rgb[0]=Cb.Sig[j*BAND];
			rgb[1]=Cb.Sig[j*BAND+1];
			rgb[2]=Cb.Sig[j*BAND+2];

		}else
		{
			for(j=0;j<STEP;j++){
				if(data[i]>rang[j]&&data[i]<rang[j+1]){
					rgb[0]=Cb.Sig[j*BAND];
					rgb[1]=Cb.Sig[j*BAND+1];
					rgb[2]=Cb.Sig[j*BAND+2];
					break;
				}
			}
		}

		/*
		if(rgb[0]==255&&rgb[1]==255&&rgb[2]==255){
			printf("%f\n",data[i]);
			getchar();
		}
		*/


		
		fwrite(rgb,sizeof(unsigned char),BAND,fp);

	}

	fclose(fp);

	printf("I\n");


}

void ColorBarImg(int STEP)
{
	FILE *fp;
	int X=1600,Y=200;
	unsigned char *rgb;
	int BAND=3;
	int i,j;
	int x,y;
	int r;
	char fnw[200];
	int *rang;

	rgb=ucvector(0,BAND);
	rang=ivector(0,STEP+1);

	CBar Cb;

	if(STEP==8){
		Cb=GetColorBar8();
		
	}else if(STEP==4){
		Cb=GetColorBar4();
		
	}else if(STEP==5){
		Cb=GetColorBar5();
		
	}else if(STEP==7){
		Cb=GetColorBar7();
	}
	else{
		printf("Not exist color bar %d !!\n",STEP);
		getchar();
		exit(1);
	}

	r=(int)X/STEP;
	rang[0]=0;

	for(i=0;i<STEP;i++){
		rang[i+1]=r*(i+1);
	}
	rang[STEP+1]=X;

	sprintf(fnw,"cbar%dimg.raw",STEP);


	for(i=0;i<STEP;i++){
		printf("Step%d RGB %d %d %d\n",i,Cb.Sig[i*BAND],Cb.Sig[i*BAND+1],Cb.Sig[i*BAND+2]);
	}


	if((fp = fopen(fnw, "wb")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}


	for(y=0;y<Y;y++){
		for(x=0;x<X;x++){

			for(j=0;j<STEP;j++){
				if(x>=rang[j]&&x<rang[j+1]){
					rgb[0]=Cb.Sig[j*BAND];
					rgb[1]=Cb.Sig[j*BAND+1];
					rgb[2]=Cb.Sig[j*BAND+2];
					break;
				}
			}


		
		fwrite(rgb,sizeof(unsigned char),BAND,fp);
		}

	}

	fclose(fp);

	printf("I\n");



}

int int_comp(const void *_a, const void *_b)
{
  int a = *(int *)_a;
  int b = *(int *)_b;
  
  if (a < b) {
    return -1;
  } else if (a > b) {
    return 1;
  } else {
    return 0;
  }
}

double *HbyKmeans_sort(char *fn,int CLASS,Wie *wimat,Dye *dye,Spec *Grass,Table *MinusLog10){

	int i,j,k;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	if(wimat->BAND!=msi.BAND){
		printf("Mistake system matrix for \n%s!!\n",msi.fn);
		printf("Please select correct file. File name is --b.system\n");
		getchar();
		exit(1);
	}

	//////////////////////////////////////////////// kmeans @ɂHFfʂNX^ɕ 
	char fn_CLS[200];
	//int CLASS=4;
	ReName(msi.fn,fn_CLS,"_obkmeans.txt");

	MapTable HER;//HER iamge 
	MapTable H;// H image

	HER=DyeGetImg(&msi,wimat,dye,Grass,MinusLog10);
	
	HER.CS=CLASS;
	HER.mean=dvector(0,HER.CS*HER.Dim);
	HER.ClaNum=ivector(0,HER.CS);

	H.Dim=1;// 1 dimension
	H.data=dvector(0,HER.Num*H.Dim);

	double *sort_mean;//Ƀ\[gꂽmean 
	sort_mean=dvector(0,HER.CS*HER.Dim);

	for(k=0;k<HER.Num;k++){
		H.data[k]=HER.data[k*HER.Dim+1];// 1 is H
	}
	H=kmeans(H.data,HER.Num,H.Dim,HER.CS);//H image ݂̂kmeans @	
	CalMean(H.MapLabel,H.ClaNum,&HER);// H kmeans 蓾ꂽϒlHER֊i[

	/////////////////////////////////////////////// j̈̌
	double max,min;
	max=-100000;
	min=10000;
	for(i=0;i<HER.CS;i++){
		j=1;//1 is H 
		if(max < HER.mean[i*HER.Dim+j])max=HER.mean[i*HER.Dim+j];
		if(min > HER.mean[i*HER.Dim+j])min=HER.mean[i*HER.Dim+j];
	}

	int *data,*order;
	data=ivector(0,HER.CS);
	order=ivector(0,HER.CS);

	for(i=0;i<HER.CS;i++){
		j=1;//1 is H 
		data[i]=(int)((HER.mean[i*HER.Dim+j]-min)/(max-min)*100);
	}

	qsort(data, HER.CS, sizeof(int), int_comp);

	for(i=0;i<HER.CS;i++){
		for(k=0;k<HER.CS;k++){
			j=1;
			if(data[i]==(int)((HER.mean[k*HER.Dim+j]-min)/(max-min)*100)){
				order[k]=i;
			}
		}
	}

	for(k=0;k<HER.CS;k++){
		for(j=0;j<HER.Dim;j++){ 
			sort_mean[order[k]*HER.Dim+j]=HER.mean[k*HER.Dim+j];
		}
	}

	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	return sort_mean;
	
}

double *RbyKmeans_sort(char *fn,int CLASS,Wie *wimat,Dye *dye,Spec *Grass,Table *MinusLog10){

	int i,j,k;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	if(wimat->BAND!=msi.BAND){
		printf("Mistake system matrix for \n%s!!\n",msi.fn);
		printf("Please select correct file. File name is --b.system\n");
		getchar();
		exit(1);
	}

	//////////////////////////////////////////////// kmeans @ɂHFfʂNX^ɕ 
	char fn_CLS[200];
	//int CLASS=4;
	ReName(msi.fn,fn_CLS,"_obkmeans.txt");

	MapTable HER;//HER iamge 
	MapTable R;// R image

	HER=DyeGetImg(&msi,wimat,dye,Grass,MinusLog10);
	
	HER.CS=CLASS;
	HER.mean=dvector(0,HER.CS*HER.Dim);
	HER.ClaNum=ivector(0,HER.CS);

	R.Dim=1;// 
	R.data=dvector(0,HER.Num*R.Dim);

	double *sort_mean;//Ƀ\[gꂽmean 
	sort_mean=dvector(0,HER.CS*HER.Dim);

	for(k=0;k<HER.Num;k++){
		R.data[k]=HER.data[k*HER.Dim+0];// 0 is H
	}
	R=kmeans(R.data,HER.Num,R.Dim,HER.CS);//R image ݂̂kmeans @	
	CalMean(R.MapLabel,R.ClaNum,&HER);//  kmeans 蓾ꂽϒlHER֊i[

	/////////////////////////////////////////////// j̈̌
	double max,min;
	max=-100000;
	min=10000;
	for(i=0;i<HER.CS;i++){
		j=0;//0 is R 
		if(max < HER.mean[i*HER.Dim+j])max=HER.mean[i*HER.Dim+j];
		if(min > HER.mean[i*HER.Dim+j])min=HER.mean[i*HER.Dim+j];
	}

	int *data,*order;
	data=ivector(0,HER.CS);
	order=ivector(0,HER.CS);

	for(i=0;i<HER.CS;i++){
		j=0;//0 is R 
		data[i]=(int)((HER.mean[i*HER.Dim+j]-min)/(max-min)*100);
	}

	qsort(data, HER.CS, sizeof(int), int_comp);

	for(i=0;i<HER.CS;i++){
		for(k=0;k<HER.CS;k++){
			j=0;//0 is R 
			if(data[i]==(int)((HER.mean[k*HER.Dim+j]-min)/(max-min)*100)){
				order[k]=i;
			}
		}
	}

	for(k=0;k<HER.CS;k++){
		for(j=0;j<HER.Dim;j++){ 
			sort_mean[order[k]*HER.Dim+j]=HER.mean[k*HER.Dim+j];
		}
	}
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	return sort_mean;
	
}

void ResiImg16Dim(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}
	
	int SX=200,EX=1800;
	int SY=200,EY=1800;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_Resi[200];

	ReName(msi.fn,fn_Resi,"_Resi16.raw");

	FILE *fp;
	printf("%s",fn_Resi);
	
	if((fp = fopen(fn_Resi, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_Resi);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}
			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}

			for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
				}
			}

			for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
				dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			}
		
			fwrite(dye16.ResiSpec,sizeof(double),dye16.WL,fp);

		}

	}

	fclose(fp);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void FileOut_DYEimg(char *fn_sys,char *fn_wsig,char *fn_Osig)
{
	int i,x,y,j;
	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	FILE *fp;
	char fn_Dye[200];//Ffʉ摜摜̃t@Ci[z
	ReName(msi.fn,fn_Dye,"_Dye.raw");//KLW摜̃t@C@[raw`] _
	printf("%s\n",fn_Dye);

	if((fp = fopen(fn_Dye, "wb")) == NULL ) {//rawint^o
		printf("%s I[vG[\n",fn_Dye);
		getchar();
		exit(1);
	}

	for(y=0;y<msi.Y;y++){
		for(x=0;x<msi.X;x++){

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat.BAND;j++){
					simSpec[i]+=wimat.mat[i*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
				simSpec[i]/=Grass.data[i];//KX̓ߗŊ
			}	

			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],&MinusLog10);
			}

			for(i=0;i<dye.Num;i++){//FfʎZo
				dye.vol[i]=0;
				for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
					dye.vol[i]+=dye.inv[dye.WL*i+j]*simSpec[j];
				}
			}
			fwrite(dye.vol,sizeof(double),dye.Num,fp);

		}
	}
	fclose(fp);

	DoubletoChar(fn_Dye,3,-3);



	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_dvector(simSpec,0,wimat.WL);

}


void DyeError(char *fn1,char *fn2,int DYEBAND)//DYEBAND͐Ff̐
{
	FILE *fp;
	double *data1;
	double *data2;
	double *dyeError;
	int DATASIZE;
	int SIZE1;
	int SIZE2;

	int i,k;
	char fnw[200];

	if((fp = fopen(fn1, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn1);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	DATASIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);
	SIZE1=(int)DATASIZE/(sizeof(double)*DYEBAND);//f
	data1=dvector(0,SIZE1*DYEBAND);// f~Ffʐǂݍ
	fread(data1,sizeof(double),SIZE1*DYEBAND,fp);
	fclose(fp);

	if((fp = fopen(fn2, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn2);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	DATASIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);
	SIZE2=(int)DATASIZE/(sizeof(double)*DYEBAND);//f

	if(SIZE1!=SIZE2){
		printf("%s \nand %s are different data size !!\n",fn1,fn2);
		getchar();
		exit(1);
	}
	data2=dvector(0,SIZE2*DYEBAND);// f~Ffʐǂݍ
	fread(data2,sizeof(double),SIZE2*DYEBAND,fp);
	fclose(fp);


	dyeError=dvector(0,DYEBAND);

	for(k=0;k<DYEBAND;k++){
		dyeError[k]=0;
	}

	for(i=0;i<SIZE1;i++){
		for(k=0;k<DYEBAND;k++){
			dyeError[k]+=(data1[i*DYEBAND+k]-data2[i*DYEBAND+k])*(data1[i*DYEBAND+k]-data2[i*DYEBAND+k]);
		}
	}

	printf("DYE ERROR \n");
	for(k=0;k<DYEBAND;k++){
		dyeError[k]/=SIZE1;
		dyeError[k]=sqrt(dyeError[k]);
		printf("%f\t",dyeError[k]);
	}
	printf("\n");

	NameJoint(fn1,fn2,fnw,"_Error.txt");//o̓t@C
	Fwrite_ProfileData(fnw,1,DYEBAND,dyeError);
	printf("%s\n",fnw);

	free_dvector(data2,0,SIZE2*DYEBAND);//
	free_dvector(data1,0,SIZE1*DYEBAND);//

}

void GetEstTransLAB(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_ROI)
{
	int i,j,k,x,y,n;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Fwrite_NVmat("test.xls",&wimat,wimat.mat);

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";//have to be 401 dim
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";//have to be 401 dim

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml
	double *dg;

	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);
	dg=dvector(0,wimat.BAND);

	double *lab;//LABl
	lab=dvector(0,xyzfunc.Num);

	double *whi_xyz;//XYZOhl
	whi_xyz=dvector(0,xyzfunc.Num);	

	for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
		whi_xyz[k]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			whi_xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k];
		}
	}

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fnw[200];
	char fnd[200];
	char fnl[200];

	ReName(fn_ROI,fnw,"_est.spec");
	ReName(fn_ROI,fnd,"_dye.txt");
	ReName(fn_ROI,fnl,"_lab.txt");
//	ReName(msi.fn,fnw,fnc);

	ROI roi;
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("test.xls",&roi);

	FILE *fp,*fp2,*fp3;
	printf("%s\n",fnw);
	char *fntmp="temporary.txt";
	
	if((fp = fopen(fnw, "w")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}
	if((fp2 = fopen(fnd, "w")) == NULL ) {
		printf("%s I[vG[\n",fnd);
		getchar();
		exit(1);
	}

	if((fp3 = fopen(fnl, "w")) == NULL ) {
		printf("%s I[vG[\n",fnl);
		getchar();
		exit(1);
	}
	
	printf("SPEC\t");
	printf("DYE\t");
	printf("LBSPEC\t");
	printf("RESI\t");
	printf("XYZ\t");
	printf("LAB\t");
		
	fprintf(fp,"\t");
	for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			fprintf(fp,"spe%d\t",i+1);
	}
	fprintf(fp,"\n");

	fprintf(fp2,"\t");
	for(i=0;i<dye.Num;i++){//FfʎZo
		fprintf(fp2,"DYE%d\t",i+1);
	}
	fprintf(fp2,"\n");



	for(n=0;n<roi.Num;n++){//ROI̐for[v
		for(j=0;j<wimat.BAND;j++){
			dg[j]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
					dg[j]+=msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			dg[j]/=roi.AREA[n];//̈TCYɒӂII
		}

		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
			simSpec[i]=0;
			for(j=0;j<wimat.BAND;j++){
				simSpec[i]+=wimat.mat[i*wimat.BAND+j]*dg[j];
			}
			simSpec[i]/=Grass.data[i];//KX̓ߗŊ
		
		}	

		fprintf(fp,"ORI\t");
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
			Do_MinusLog10(&simSpec[i],&MinusLog10);
			fprintf(fp,"%f\t",simSpec[i]);
		}
		fprintf(fp,"\n");

		fprintf(fp2,"DYE\t");
		for(i=0;i<dye.Num;i++){//FfʎZo
			dye.vol[i]=0;
			for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
				dye.vol[i]+=dye.inv[dye.WL*i+j]*simSpec[j];
			}
			fprintf(fp2,"%f\t",dye.vol[i]);
		}
		fprintf(fp2,"\n");

	
		fprintf(fp,"LB\t");
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
			dye.LBSpec[i]=0;
			for(j=0;j<dye.Num;j++){
				dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
			}
			fprintf(fp,"%f\t",dye.LBSpec[i]);
		}
		fprintf(fp,"\n");
		

		fprintf(fp,"RESI\t");
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
			dye.ResiSpec[i]=simSpec[i]-dye.LBSpec[i];
			fprintf(fp,"%f\t",dye.ResiSpec[i]);
		}
		fprintf(fp,"\n");
		

		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//ߗ֕ϊ
			Do_Minus10Power(&simSpec[i],&Minus10Power);
			simSpec[i]*=Grass.data[i];//KX̓ߗ
		}

		fprintf(fp3,"XYZ\t");
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			xyz[k]=0;
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
				xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k]*simSpec[i];
			}
			fprintf(fp3,"%f\t",xyz[k]);
		}
		fprintf(fp3,"\n");
		
		XYZtoLAB(xyz,whi_xyz,lab);

		fprintf(fp3,"Lab\t");
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			fprintf(fp3,"%f\t",lab[k]);
		}
		fprintf(fp3,"\n");
		

		for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
			irgb[k]=0;
			for(j=0;j<xyzfunc.Num;j++){
				irgb[k]+=dsp.XtoD[k*xyzfunc.Num+j]*xyz[j];
			}
		}

		RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml

	}
	fclose(fp);
	fclose(fp2);
	fclose(fp3);

//	Fwrite_TF(fnw,roi.Num*3,(wimat.END-wimat.START)/wimat.INTERVAL);


	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void ResiImg16Dim_NSEImg(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}
	
	int SX=200,EX=1800;
	int SY=200,EY=1800;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_Resi[200];
	double Rpower,Opower,NSE;

	ReName(msi.fn,fn_Resi,"_Resi16_NSE.raw");

	FILE *fp;
	printf("%s",fn_Resi);
	
	if((fp = fopen(fn_Resi, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_Resi);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}
			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}

			for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
				}
			}

			for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
				dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			}

			//Normalized Squar Error  (NSE) ̌vZ
			Rpower=0;
			for(i=0;i<dye16.WL;i++){
				Rpower+=dye16.ResiSpec[i]*dye16.ResiSpec[i];
			}
			Opower=0;
			for(i=0;i<dye16.WL;i++){
				Opower+=spec16[i]*spec16[i];
			}
			NSE=Rpower/Opower;

			fwrite(&NSE,sizeof(double),1,fp);//NSE摜̎Zo

		}

	}

	fclose(fp);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void ColorImage_UseDye16Dim(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	//char fn_dye16[]="NormalizedResiPC1_R(no)_HE_upmc16ODsignalfrom401dim.spec";
	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs

	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_rgb[200];

	char name[200];
	RGB rgb;

	sprintf(name,"_LB_dye%d_rgb.raw",dye16.Num);
	ReName(msi.fn,fn_rgb,name);
	rgb=RGBinfo(&msi,fn_rgb);


	FILE *fp;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}
			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}

			for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 
				dye16.LBSpec[i]=0;
				for(j=0;j<dye16.Num;j++){
					dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
				}
			}

			for(i=0;i<dye16.WL;i++){//LBɊÂzx O.K. 
				dye16.ChagSpec[i]=dye16.LBSpec[i];
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
				dye16.ChagSpec[i]+=Grass16.data[i];
			}
			for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
				Do_Minus10Power(&dye16.ChagSpec[i],&Minus10Power);
			}

			///////////////////////////////////16ԂŒ I/////////////////////////

			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				irgb[k]=0;
				for(i=0;i<wimat.BAND;i++){
						//irgb[k]+=StoI[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
						irgb[k]+=StoI[k*wimat.BAND+i]*dye16.ChagSpec[i]*wg[i];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
	
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);
		}

	}

	fclose(fp);	
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void ROI_Spect_Dye_LAB_16Dim(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16,char *fn_ROI)
{
	int i,j,k,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	//char fn_dye16[]="NormalizedResiPC1_R(no)_HE_upmc16ODsignalfrom401dim.spec";
	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml

	double *lab;//LABl
	lab=dvector(0,xyzfunc.Num);

	double *whi_xyz;//XYZOhl
	whi_xyz=dvector(0,xyzfunc.Num);	

	for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
		whi_xyz[k]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			whi_xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k];
		}
	}

	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}

	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fnw[200],name_sp[200];
	char fnd[200],name_dye[200];
	char fnl[200],name_lab[200];

	sprintf(name_sp,"_Est_Dye%d.spec",dye16.Num);
	sprintf(name_dye,"_Dye%d.txt",dye16.Num);
	sprintf(name_lab,"_Lab_Dye%d.txt",dye16.Num);

	ReName(fn_ROI,fnw,name_sp);
	ReName(fn_ROI,fnd,name_dye);
	ReName(fn_ROI,fnl,name_lab);


	ROI roi;
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("Check_ROIdata.xls",&roi);

	FILE *fp,*fp2,*fp3;

	double *dg;
	dg=dvector(0,wimat.BAND);//ϐMl
	
	if((fp = fopen(fnw, "w")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}
	if((fp2 = fopen(fnd, "w")) == NULL ) {
		printf("%s I[vG[\n",fnd);
		getchar();
		exit(1);
	}

	if((fp3 = fopen(fnl, "w")) == NULL ) {
		printf("%s I[vG[\n",fnl);
		getchar();
		exit(1);
	}
	
	printf("SPEC\t");
	printf("DYE\t");
	printf("LBSPEC\t");
	printf("RESI\t");
	printf("XYZ\t");
	printf("LAB\t");

	fprintf(fp,"\t");
	for(i=0;i<wimat.BAND;i++){
			fprintf(fp,"spe%d\t",i+1);
	}
	fprintf(fp,"\n");

	fprintf(fp2,"\t");
	for(i=0;i<dye16.Num;i++){//FfʎZo
		fprintf(fp2,"DYE%d\t",i+1);
	}
	fprintf(fp2,"\n");

	
	for(int n=0;n<roi.Num;n++){//ROI̐for[v

		for(j=0;j<wimat.BAND;j++){
			dg[j]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
					dg[j]+=msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			dg[j]/=roi.AREA[n];
		}

		///////////////////////////////////16ԂŒ@Jn/////////////////////////

		for(i=0;i<wimat.BAND;i++){//ߗMlZo
			spec16[i]=dg[i]/wg[i];
		}

		for(i=0;i<wimat.BAND;i++){//zx֕ϊ
			Do_MinusLog10(&spec16[i],&MinusLog10);
		}
		fprintf(fp,"ORI\t");
		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
			spec16[i]-=Grass16.data[i];
			fprintf(fp,"%f\t",spec16[i]);
		}
		fprintf(fp,"\n");

		fprintf(fp2,"DYE\t");
		for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
			dye16.vol[j]=0;
			for(i=0;i<dye16.WL;i++){
				dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
			}
			fprintf(fp2,"%f\t",dye16.vol[j]);
		}
		fprintf(fp2,"\n");

		fprintf(fp,"LB\t");
		for(i=0;i<dye16.WL;i++){//LBɊÂzx  data[WL][Num]  O.K. 07/05/22
			dye16.LBSpec[i]=0;
			for(j=0;j<dye16.Num;j++){
				dye16.LBSpec[i]+=dye16.data[i*dye16.Num+j]*dye16.vol[j];
			}
			fprintf(fp,"%f\t",dye16.LBSpec[i]);
		}
		fprintf(fp,"\n");

		fprintf(fp,"RESI\t");
		for(i=0;i<dye16.WL;i++){//cXyNg O.K. 07/05/22
			dye16.ResiSpec[i]=spec16[i]-dye16.LBSpec[i];
			fprintf(fp,"%f\t",dye16.ResiSpec[i]);
		}
		fprintf(fp,"\n");

		for(i=0;i<dye16.WL;i++){//Wzx O.K. 07/05/22
			//dye16.ChagSpec[i]=dye16.ResiSpec[i]+dye16.LBSpec[i];
			dye16.ChagSpec[i]=dye16.LBSpec[i];//2007/8/14ύX
		}

		for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂŖ߂ij
			dye16.ChagSpec[i]+=Grass16.data[i];
		}
		for(i=0;i<wimat.BAND;i++){//ߗ֕ϊ
			Do_Minus10Power(&dye16.ChagSpec[i],&Minus10Power);
		}

		fprintf(fp3,"XYZ\t");
		for(k=0;k<xyzfunc.Num;k++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
			xyz[k]=0;
			for(i=0;i<wimat.BAND;i++){
				xyz[k]+=StoX[k*wimat.BAND+i]*dye16.ChagSpec[i]*wg[i];
			}
			fprintf(fp3,"%f\t",xyz[k]);
		}
		fprintf(fp3,"\n");

		XYZtoLAB(xyz,whi_xyz,lab);

		fprintf(fp3,"Lab\t");
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			fprintf(fp3,"%f\t",lab[k]);
		}
		fprintf(fp3,"\n");

	}

	fclose(fp);
	fclose(fp2);
	fclose(fp3);

	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);

	free_dvector(simSpec,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);


}

void DyeImg16Dim(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_dye16)
{
	int i,j,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	
	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_Dimg[200];
	char name[200];

	sprintf(name,"_%ddye_16dim.raw",dye16.Num);

	ReName(msi.fn,fn_Dimg,name);

	FILE *fp;
	printf("%s",fn_Dimg);
	
	if((fp = fopen(fn_Dimg, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_Dimg);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}
			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}
		
			fwrite(dye16.vol,sizeof(double),dye16.Num,fp);

		}

	}

	fclose(fp);	



	//*******************************  Make dye image have char type ************************** 
	double omax=3;
	double omin=-3;
	DoubletoChar(fn_Dimg,omax,omin);

	//*****************************************************************************************

	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	
	free_dvector(simSpec,0,wimat.WL);

}

void WriteBinaryImage(char *fn_BIimage)
{
	FILE *fp;
	unsigned char *data;
	unsigned char *rgb;	
	int Num;
	int RGB_BAND=3;

	data=GetCharImg(fn_BIimage,&Num);
	rgb=ucvector(0,RGB_BAND);

	char fnw[200];
	int i,j;

	CBar Cb;
	Cb=GetColorBar5();

	ReName(fn_BIimage,fnw,"_toRGB.raw");
	printf("%s file open !! \n",fnw);
	
	if((fp = fopen(fnw, "wb")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}

	for(i=0;i<Num;i++){
		if(data[i]==0){
			for(j=0;j<RGB_BAND;j++){
				rgb[j]=Cb.Sig[j];
			}
		}
		else{
			for(j=0;j<RGB_BAND;j++){
				rgb[j]=Cb.Sig[3*RGB_BAND+j];
			}
		}
		fwrite(rgb,sizeof(unsigned char),RGB_BAND,fp);
	}
	fclose(fp);

	free_ucvector(data,0,Num);



}

void Dyetxt16Dim_FromBinaryImage(char *fn_sys,char *fn_wsig,char *fn_Osig,char *fn_BIimage,char *fn_dye16)
{
	int i,j,x,y;

	Wie wimat;
	double *wg;// O.K. 07/05/22
	double *spec16;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	wg=dvector(0,wimat.BAND);
	spec16=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){//calculation white signal
		wg[j]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			wg[j]+=wimat.tr_H[i*wimat.BAND+j]*1;
		}
	}

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	char fn_grass16[]="..\\DATA\\grassOD16.spec";

	DyeV2 dye16;// O.K. 07/05/22
	dye16.data=DataGet(fn_dye16,&dye16.WL,&dye16.Num);//data[WL][Num]
	dye16.inv=GetSVDInverse(dye16.data,dye16.WL,dye16.Num);//inv[Num][WL]

	dye16.vol=dvector(0,dye16.Num);//Ff
	dye16.ChagSpec=dvector(0,dye16.WL);//XyNg
	dye16.ResiSpec=dvector(0,dye16.WL);//cXyNg
	dye16.LBSpec=dvector(0,dye16.WL);//LBŕ\Ƃ\ȓߗ

	Spec Grass16;//O.K. 07/05/22
	Grass16=SpecGet(fn_grass16);

	
	int SX=0,EX=2048;
	int SY=0,EY=2048;

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);


	//**************************  ot@Č@**********************************
	char fnw[200];
	char name[200];
	sprintf(name,"_Dye%dfromBinary.txt\n",dye16.Num);
	ReName(fn_Osig,fnw,name);


	//******************************* 2lʉ摜ǂݍ****************************************
	unsigned char *BIimg;//2l摜
	int Pix;//f
	int AreaPix=0;//Ώۗ̈̉f
	double *ave_dye;//ϐFf

	ave_dye=dvector(0,dye16.Num);
	BIimg=GetCharImg(fn_BIimage,&Pix);//@READ Binary Image !!
	
	if(Pix!=(msi.X*msi.Y)){
		printf("Mistake selected file is %s\n",fn_BIimage);
		getchar();
		exit(1);
	}


	FILE *fp;
	printf("%s",fnw);
	
	if((fp = fopen(fnw, "w")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}

	for(j=0;j<dye16.Num;j++){
		ave_dye[j]=0;
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			///////////////////////////////////16ԂŒ@Jn/////////////////////////

			for(i=0;i<wimat.BAND;i++){//ߗMlZo
						spec16[i]=msi.data[y*msi.X*msi.BAND+x*msi.BAND+i]/wg[i];
			}
			for(i=0;i<wimat.BAND;i++){//zx֕ϊ
				Do_MinusLog10(&spec16[i],&MinusLog10);
			}
			for(i=0;i<wimat.BAND;i++){//KX̋zxzxԂň
				spec16[i]-=Grass16.data[i];
			}

			for(j=0;j<dye16.Num;j++){//FfʎZo inv[Num][WL] // O.K. 07/05/22
				dye16.vol[j]=0;
				for(i=0;i<dye16.WL;i++){
					dye16.vol[j]+=dye16.inv[j*dye16.WL+i]*spec16[i];
				}
			}

			if(BIimg[y*msi.X+x]==255){//Ώۗ̈̐MlZ

				for(j=0;j<dye16.Num;j++){
					ave_dye[j]+=dye16.vol[j];
				}
				AreaPix++;
			}
		
		}

	}

	fclose(fp);	

	printf("Number of pixcel is %d\n",AreaPix);

	for(j=0;j<dye16.Num;j++){
		ave_dye[j]/=AreaPix;
		printf("DYE%d=%f\t",j+1,ave_dye[j]);
	}
	printf("\n");

	Fwrite_ProfileData(fnw,1,dye16.Num,ave_dye);
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);



}

Dye Do_Dmat_IMSPEC(char *fn_dye,Wie *wimat,Table *MinusLog10)
{
	int i,j;
	Dye dye;
	dye.spec=SpecGet(fn_dye);

	dye.Num=dye.spec.Num;
	dye.WL=dye.spec.WL;
	dye.inv=dvector(0,dye.Num*dye.WL);
	dye.vol=dvector(0,dye.Num);
	dye.INTERVAL=wimat->INTERVAL;
	dye.START=40;//420nm@is start wavelength in calculation of dye amount.
	dye.END=321;//700nm is end wavelength in calculation of dye amount.

	dye.ChagSpec=dvector(0,wimat->WL);//XyNg
	dye.ResiSpec=dvector(0,wimat->WL);//cXyNg
	dye.LBSpec=dvector(0,wimat->WL);//LBŕ\Ƃ\ȓߗ

	for(i=0;i<dye.WL;i++){
		for(j=0;j<dye.Num;j++){
			Do_MinusLog10(&dye.spec.data[i*dye.Num+j],MinusLog10);
		}
	}

	NormalizeDyespec(&dye);//zx̍ől1ɂ

	double *tempdata,*tpinv;
	int UseDim;//

	if(dye.INTERVAL==1){
			UseDim=int((dye.END-dye.START)/dye.INTERVAL);
	}else{
			UseDim=int((dye.END-dye.START)/dye.INTERVAL)+1;
	}

	tempdata=dvector(0,UseDim*dye.Num);
	tpinv=dvector(0,dye.Num*UseDim);

	for(j=0;j<dye.Num;j++){
		for(i=dye.START;i<dye.END;i+=dye.INTERVAL){
			tempdata[((i-dye.START)/dye.INTERVAL)*dye.Num+j]=dye.spec.data[i*dye.Num+j];
		}
	}

	svdinv_zeromat1D(tempdata,tpinv,UseDim,dye.Num);//[ts̍쐬

	for(j=0;j<dye.Num;j++){
		for(i=0;i<dye.WL;i++){
			dye.inv[j*dye.WL+i]=0;
		}
	}

	for(j=0;j<dye.Num;j++){
		for(i=0;i<UseDim;i++){
			dye.inv[j*dye.WL+i*dye.INTERVAL+dye.START]=tpinv[j*UseDim+i];
		}
	}

	free_dvector(tempdata,0,UseDim*dye.Num);
	free_dvector(tpinv,0,dye.Num*UseDim);


	return dye;

}

void ROI_Error_Spect_Dye_LAB_Imspec(char *fn_Imspec,char *fn_ROI)
{
	int i,j,k,x,y,n;

	Wie wimat;
	wimat=Do_WmatIMSPEC();//wieners͍쐬ȂAgohȂǂ̃p[^

	//Fwrite_NVmat("test.xls",&wimat,wimat.mat);

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";//have to be 401 dim
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";//have to be 401 dim

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat_IMSPEC(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	
	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);

	double *ImSpec401;////Imspector̃XyNg401̔z֊i[
	ImSpec401=dvector(0,wimat.WL);

	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml
	double *dg;

	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);
	dg=dvector(0,wimat.BAND);

	double *lab;//LABl
	lab=dvector(0,xyzfunc.Num);

	double *whi_xyz;//XYZOhl
	whi_xyz=dvector(0,xyzfunc.Num);	

	for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
		whi_xyz[k]=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			whi_xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k];
		}
	}

	//Imspector 摜̓ǂݍ
	MSI SPW;
	SPW=MSIGet_V2(fn_Imspec);

	ROI roi;//ROIf[^̓ǂݍ
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("test.xls",&roi);

	FILE *fp,*fp2,*fp3;

	char fnw[200];
	char fnd[200];
	char fnl[200];

	ReName(fn_ROI,fnw,".spec");
	ReName(fn_ROI,fnd,"_dye.txt");
	ReName(fn_ROI,fnl,"_lab.txt");
	printf("%s\n",fnw);


	
	if((fp = fopen(fnw, "w")) == NULL ) {
		printf("%s I[vG[\n",fnw);
		getchar();
		exit(1);
	}
	if((fp2 = fopen(fnd, "w")) == NULL ) {
		printf("%s I[vG[\n",fnd);
		getchar();
		exit(1);
	}

	if((fp3 = fopen(fnl, "w")) == NULL ) {
		printf("%s I[vG[\n",fnl);
		getchar();
		exit(1);
	}
	
	printf("SPEC\t");
	printf("DYE\t");
	printf("LBSPEC\t");
	printf("RESI\t");
	printf("XYZ\t");
	printf("LAB\t");
		
	fprintf(fp,"\t");
	for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
			fprintf(fp,"spe%d\t",i+1);
	}
	fprintf(fp,"\n");

	fprintf(fp2,"\t");
	for(i=0;i<dye.Num;i++){//FfʎZo
		fprintf(fp2,"DYE%d\t",i+1);
	}
	fprintf(fp2,"\n");


	int dx=1;// dark current
	int wx=0;// white current
	double d1,d2;
	double *imspe;
	imspe=dvector(0,SPW.BAND);

	for(n=0;n<roi.Num;n++){//ROI̐for[v
		
		for(k=0;k<SPW.BAND;k++){//ߗ֕ϊ
			imspe[k]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
					d1=(double)(SPW.data[x*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);
					d2=(double)(SPW.data[wx*SPW.Y*SPW.BAND+y*SPW.BAND+k]-SPW.data[dx*SPW.Y*SPW.BAND+y*SPW.BAND+k]);

					if(d2==0){
						d1=0;
					}else{
						d1/=d2;
					}

					imspe[k]+=d1;
				}
			}
			imspe[k]/=roi.AREA[n];
		}

		//401̔z֊i[
		k=0;
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//KX̓ߗŊ
			ImSpec401[i]=imspe[k];///Grass.data[i];
			k++;
		}

		fprintf(fp,"ORI\t");
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//zx֕ϊ
			Do_MinusLog10(&ImSpec401[i],&MinusLog10);
			fprintf(fp,"%f\t",ImSpec401[i]);
		}
		fprintf(fp,"\n");

		//***********************    FfʎZo鎞̔g͈͂ύX@******************///
		fprintf(fp2,"DYE\t");
		for(i=0;i<dye.Num;i++){//FfʎZo
			dye.vol[i]=0;
			for(j=dye.START;j<dye.END;j+=wimat.INTERVAL){
				dye.vol[i]+=dye.inv[dye.WL*i+j]*ImSpec401[j];
			}
			fprintf(fp2,"%f\t",dye.vol[i]);
		}
		fprintf(fp2,"\n");
		//**************************************************************************************

		fprintf(fp,"LB\t");
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
			dye.LBSpec[i]=0;
			for(j=0;j<dye.Num;j++){
				dye.LBSpec[i]+=dye.spec.data[i*dye.Num+j]*dye.vol[j];
			}
			fprintf(fp,"%f\t",dye.LBSpec[i]);
		}
		fprintf(fp,"\n");
		
		fprintf(fp,"RESI\t");
		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//LBɊÂzx
			dye.ResiSpec[i]=ImSpec401[i]-dye.LBSpec[i];
			fprintf(fp,"%f\t",dye.ResiSpec[i]);
		}
		fprintf(fp,"\n");

		for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//ߗ֕ϊ
			Do_Minus10Power(&ImSpec401[i],&Minus10Power);
			ImSpec401[i]*=Grass.data[i];//KX̓ߗ
		}

		fprintf(fp3,"XYZ\t");
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			xyz[k]=0;
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
				xyz[k]+=xyzfunc.data[i*xyzfunc.Num+k]*ImSpec401[i];
			}
			fprintf(fp3,"%f\t",xyz[k]);
		}
		fprintf(fp3,"\n");
		
		XYZtoLAB(xyz,whi_xyz,lab);

		fprintf(fp3,"Lab\t");
		for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			fprintf(fp3,"%f\t",lab[k]);
		}
		fprintf(fp3,"\n");

	}

	fclose(fp);
	fclose(fp2);
	fclose(fp3);


	free_usvector(SPW.data,0,SPW.X*SPW.Y*SPW.BAND);	
	free_dvector(ImSpec401,0,wimat.WL);
	free_dvector(xyz,0,xyzfunc.Num);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);

}
